from cms.include import *
from cms.data_providers import base as dd


class Flask(Flask):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

    def route(self, rule, **options):
        def decorator(f):
            endpoint = options.pop('endpoint', None)
            module_path = f.__module__
            module_name = module_path.split('.')[-3]
            if module_name != 'index':
                url = '/' + module_name + rule
            else:
                url = rule
            if endpoint is None:
                endpoint = module_name + '.' + f.__name__
            self.add_url_rule(url, endpoint, f, **options)
            print(endpoint)
            # TODO: если endpoint есть при регистрации - переопределять
            return f
        return decorator


def send_static(req_filename):
    for directory in [os.path.join(config.PROJECT_DIR, d) for d in ['custom/static/',
                                                        'common/static/',
                                                        'cms/static/']]:

        filename = flask.helpers.safe_join(directory, req_filename)
        if not os.path.isabs(filename):
            filename = os.path.join(directory, filename)
        try:
            if not os.path.isfile(filename):
                continue
        except (TypeError, ValueError):
            raise flask.helpers.BadRequest()
        return flask.helpers.send_file(filename, conditional=True)
    raise flask.helpers.NotFound()


APP = Flask(__name__, static_folder=None, root_path=config.PROJECT_DIR)
APP.add_url_rule('/static/<path:req_filename>', endpoint='static', view_func=send_static)


@APP.before_request
def before_request():
    dd.before_request()


@APP.before_first_request
def before_first_request():
    dd.before_first_request()


@APP.teardown_request
def teardown_request(exception=None):
    dd.teardown_request(exception=exception)
    # todo Обработка исключений
