################################################################
# Copyright © 2005 - 2019 CarbonSoft.
# All rights reserved.
# Site: https://www.carbonsoft.ru.
################################################################

<?php
//define(DEBUG,true);
$file = fopen('/cfg/fiscal.json', 'r');
$filedata = fread($file, filesize('/cfg/fiscal.json'));
$ini_file = json_decode($filedata, true);
$rentsoft_en = $ini_file["rentsoft"]["enable"][0];

class Cabinet extends CI_Controller
{
    var $meta = array();
    var $data = array();
    var $service;
    var $hdsk_ticket_status = array(
        '0' => 'Открыто',
        '1' => 'Ожидает ответа',
        '10' => 'Закрыто'
    );


    public function special_search_check()
    {
        if (isset($_SESSION['cab']['session_id']) && $_SESSION['cab']['session_id'] > 0 && !in_array($this->router->method, array('detail_search', 'logout', 'detail_user'))) {
            $user_get_data = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $_SESSION['cab']['user_id'] . ', null)');
            if ($user_get_data['IS_ALLOW_SEARCH'] > 0) {
                header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/detail_search/");
                die();
            }
        }
    }


    public function __construct()
    {
        global $rentsoft_en;
        session_start();
        parent::__construct();
        $this->special_search_check();

        Error_Reporting(E_ALL & ~E_NOTICE & ~E_WARNING);
        $this->__redirect2https();
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() >= 3)
            $view_id = (int)$this->uri->rsegment(3, 1);
        $sql = 'SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)';
        $this->data['user'] = $this->ideco_db->cabQuerySingle($sql);
        $this->meta['title'] = 'Личный кабинет';
        if ($this->data['user']['CONTRACT_NUMBER'] != '<')
            $this->meta['title'] .= ' - ' . $this->data['user']['CONTRACT_NUMBER'];
        $this->meta['keywords'] = '';
        $this->meta['description'] = '';
        $suid = $_SESSION['cab']['session_id'];
        $this->data['title'] = $this->meta['title'];
        $this->data['content'] = '';
        $this->data['login_error'] = '';
        $this->cabinet['menu'][] = array('name' => 'userinfo', 'title' => 'Информация');
        $show_payment = $this->ideco_db->get_vpn_const($suid, '70');
        if (!$show_payment or $show_payment == null) {
            $this->cabinet['menu'][] = array('name' => 'payment', 'title' => 'Оплата');
        }
        $this->cabinet['menu'][] = array('name' => 'stat', 'title' => 'Статистика');
//        $this->cabinet['menu'][] = array('name' => 'audit', 'title' => 'Аудит');
        $show_audit = $this->ideco_db->get_vpn_const($suid, '31');
        if ($show_audit or $show_audit == null) {
            $this->cabinet['menu'][] = array('name' => 'audit', 'title' => 'Аудит');
        }
        $show_bills = $this->ideco_db->get_vpn_const($suid, '62');
        if ($show_bills or $show_bills == null) {
            $this->cabinet['menu'][] = array('name' => 'operations', 'title' => 'Документы');
        }
        $show_tarif = $this->ideco_db->get_vpn_const($suid, '69');
        if ($show_tarif != 1 or $show_tarif == null) {
            $this->cabinet['menu'][] = array('name' => 'tarif', 'title' => 'Тариф');
        }
        $this->cabinet['menu'][] = array('name' => 'uservices', 'title' => 'Услуги');
        $this->cabinet['menu'][] = array('name' => 'control', 'title' => 'Управление');
        if ($rentsoft_en == 1)
            $this->cabinet['menu'][] = array('name' => 'podpiska', 'title' => 'Подписка');
        if ($_SESSION['cab']['isadmin'] == 1)
            $this->cabinet['menu'][] = array('name' => 'sysmon', 'title' => 'Системный монитор');
//        if ($_SESSION['cab']['isadmin'] == 1)
        $show_voip = $this->ideco_db->get_vpn_const($suid, '76');
        if ($show_voip or $show_voip == null) {
            $this->cabinet['menu'][] = array('name' => 'reports/voip', 'title' => 'Статистика VOIP');
        }
        $show_vidimax = $this->ideco_db->get_vpn_const($suid, '73');
        if ($show_vidimax or $show_vidimax == null) {
            $this->cabinet['menu'][] = array('name' => 'vidimax', 'title' => 'Vidimax');
        }
        $show_helpdesk = $this->ideco_db->get_vpn_const($suid, '56');
//        if ($_SESSION['cab']['show_helpdesk'] == 1) {
        if ($show_helpdesk or $show_helpdesk == null) {
            $this->cabinet['menu'][] = array('name' => 'helpdesk', 'title' => 'HelpDesk');
        }
//        $show_bills = $this->ideco_db->get_vpn_const($suid, '62');
//        if ($show_bills or $show_bills == null) {
//            $this->cabinet['menu'][] = array('name' => 'documents', 'title' => 'Документы');
//        }
        $this->cabinet['cur_tab'] = 'userinfo';
        $this->data['breadcrumbs'] = array("Главная" => "/", "Личный кабинет" => "/cabinet/");
    }

    function __unauth_redir()
    {
        $URI = $_SERVER['REQUEST_URI'];
        $_SESSION['cab']['URI1'] = $URI;
        $URI1 = explode("/", $URI);
        if ($URI1['1'] == 'cabinet') {
            //$_SESSION['cab']['URI1']=$this->cabinet['menu'];
            $_SESSION['cab']['URI'] = "";
            foreach ($this->cabinet['menu'] as $num) {
                $nname = $num['name'];
                //$_SESSION['cab'][$nname] = $nname;
                if ($URI1['2'] == $nname) {
                    $_SESSION['cab']['URI'] = $URI;
                }
            }
        }

        if (!isset($_SESSION['cab']['session_id'])) {
            header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/");
            $this->__redirect2https;
        }
    }

    function __show_login()
    {
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');
        $_SESSION['random_word'] = rand(0, 999999);
        $this->data['theme'] = $theme;
        $this->meta['theme'] = $theme;
        $this->load->view("$view/../cabinet/html_start", $this->meta);
        $this->load->view("$view/../cabinet/header_simple");
        $this->load->view("$view/../cabinet/login", $this->data);
        $this->load->view("$view/../cabinet/footer");
        $this->load->view("$view/../cabinet/html_end");
    }

    function __show_page($page)
    {
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');
        $this->data['theme'] = $theme;
        $this->meta['theme'] = $theme;
        $this->meta['logo'] = true;
        $this->load->view("$view/../cabinet/html_start", $this->meta);
        $this->load->view("$view/../cabinet/header_simple");
        $this->load->view("$view/../cabinet/data_start", $this->data);
        $this->load->view("$view/../cabinet/menu", $this->cabinet);
        $this->load->view("$view/../cabinet/" . $page, $this->data);
        $this->load->view("$view/../cabinet/data_end");
        $this->load->view("$view/../cabinet/footer");
        $this->load->view("$view/../cabinet/html_end");
    }

    function parse_cfg()
    {
        $filedata = file_get_contents('/cfg/fiscal.json');
        $arr = json_decode($filedata, true);
        //if (DEBUG) {print '<pre>'; print_r($arr); print '</pre>';}
        return $arr;
    }

    function __redirect2https()
    {
        $ini_file = array();
        $ini_file = parse_ini_file('/etc/ics/ics.conf', false);
        foreach ($ini_file as $key => $value)
            $ini_file[$key] = rtrim(ltrim($value, "'\""), "'\"");
        if ($ini_file["WEB_ONLYSSL"] == "1" && $_SERVER['SERVER_PORT'] != 443) {
            header('Location: ' . "https://{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}");
            echo "<meta http-equiv=\"Refresh\" content=\"0; " . "url=https://{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}\">";
            exit(0);
        }
    }

    function index()
    {
        $this->data['title'] = $this->meta['title'];
        $this->data['content'] = '';
        $show_login = 0;
//try autologon
        if (!isset($_SESSION['cab']['session_id'])) //TODO: && ( !isset( $_SESSION['login_error'] ) )
            $this->__try_auto_login();
        if (isset($_SESSION['login_error'])) {
            $this->data['login_error'] = $_SESSION['login_error'];
            unset($_SESSION['login_error']);
        }
        if (!isset($_SESSION['cab']['session_id'])) {
            $this->__show_login();
        } else {
            if ($_SESSION['cab']['URI'] != '') {
                header('Location: ' . "http://{$_SERVER['HTTP_HOST']}" . $_SESSION['cab']['URI']);
                $this->__redirect2https();
            } else {
                header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/userinfo");
                $this->__redirect2https();
            }
        }
    }

    function __try_auto_login()
    {
        $this->__redirect2https();
        $dbh = $this->ideco_db->connectDB();
        $host = $_SERVER['REMOTE_ADDR'];
        $sql = "SELECT * FROM WEB_USER_LOGIN('','','{$host}')";
//        $result = @$this->ideco_db->ibase_query_win1251($dbh, $sql, false);
        $result = $this->ideco_db->cabQuerySingle($sql);
        if (ibase_errcode()) {
            sleep(2);
            $_SESSION['login_error'] = 'LOgin:' . $this->ideco_db->dbException();
            return;
        }
//	Так делать больше нельзя
//      $user_params = $this->ideco_db->ibase_fetch_assoc_win1251($result);
        $user_params = $result;
        foreach ($user_params as $key => $val) {
            $_SESSION['cab'][strtolower($key)] = $user_params[$key];
        }
        $_SESSION['cab']['id'] = $_SESSION['cab']['user_id'];
        $sql = "SELECT * FROM WEB_IS_AUDIT_SHOW";
        $result = @$this->ideco_db->ibase_query_win1251($dbh, $sql, false);
        $a_params = $this->ideco_db->ibase_fetch_assoc_win1251($result);
        $_SESSION['cab']['show_audit'] = $a_params['IS_SHOW'];
//        $_SESSION['cab']['show_helpdesk'] = $a_params['IS_SHOW_HDSK'];
        $this->ideco_db->disconnectDB($dbh);
    }

    function passwd_restore()
    {
        $this->__redirect2https();
        $this->data['title'] = 'Востановление пароля';
        if ($_POST) {
            $dbh = $this->ideco_db->connectDB();
            $contr_numb = $_POST['contr_numb'];
            $email = $_POST['email'];
            $host = $_SERVER['REMOTE_ADDR'];
            $sql = "SELECT * FROM WEB_USER_PASSWORD_RESTORE('{$contr_numb}', '{$email}')";
            #$sql = "SELECT * FROM NEW_PROCEDURE('{$email}', '{$contr_numb}')";
            $result = $this->ideco_db->cabQuerySingle($sql);
            $error = $result['ERROR'];
            if (ibase_errcode() || $error <> 0) {
                $this->data['restore_error'] = 'Ошибка. Проверьте правильность вводимых данных.';
                #header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/passwd_restore");
                #$this->__redirect2https();
            } else {
                $this->ideco_db->disconnectDB($dbh);
                $this->data['restore_error'] = 'Пароль выслан на почту.';
                #header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/");
                #$this->__redirect2https();
            }
        }
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');
        $this->data['theme'] = $theme;
        $this->meta['theme'] = $theme;
        $this->load->view("$view/../cabinet/html_start", $this->meta);
        $this->load->view("$view/../cabinet/header_simple");
        $this->load->view("$view/../cabinet/passwd_restore", $this->data);
        $this->load->view("$view/../cabinet/footer");
        $this->load->view("$view/../cabinet/html_end");
    }

    function login()
    {
        $this->__redirect2https();
        $dbh = $this->ideco_db->connectDB();
        $login = $this->ideco_cab->cabRequest('cab_login', 'str', '');
        $password = $this->ideco_cab->cabRequest('cab_password', 'str', '');
        $random_word = $_SESSION['random_word'];
        $hash = $this->ideco_cab->cabRequest('cab_hash', 'str', '');
        $host = $_SERVER['REMOTE_ADDR'];
        $sql = "SELECT * FROM WEB_USER_LOGIN2('{$login}', '{$random_word}', '{$hash}', '{$password}', '{$host}')";
        //нельзя, фу
        //$result = @$this->ideco_db->ibase_query_win1251($dbh, $sql);
        $result = $this->ideco_db->cabQuerySingle($sql);
        if (ibase_errcode()) {
            sleep(2);
            $_SESSION['login_error'] = $this->ideco_db->dbException();
            $_SESSION['login_error'] = 'Пожалуйста, введите корректные имя пользователя и пароль. Оба поля могут быть чувствительны к регистру.';
            header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/");
            $this->__redirect2https();
            return;
        }
        //$user_params = $this->ideco_db->ibase_fetch_assoc_win1251($result);
        $user_params = $result;
        foreach ($user_params as $key => $val) {
            $_SESSION['cab'][strtolower($key)] = $user_params[$key];
        }
        $_SESSION['cab']['id'] = $_SESSION['cab']['user_id'];
        //$sql = "SELECT * FROM WEB_IS_AUDIT_SHOW";
        //$result = @$this->ideco_db->ibase_query_win1251($dbh, $sql, false);
        //$a_params = $this->ideco_db->ibase_fetch_assoc_win1251($result);
        $_SESSION['cab']['show_audit'] = false;
        //$a_params['IS_SHOW'];
        $this->ideco_db->disconnectDB($dbh);
        header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/");
        $this->__redirect2https();
    }

    private function get_proc_params_str($arParams, $addtitional_params = array())
    {
        $arParams = array_merge($arParams, $addtitional_params);
        $proc_params_tmp_ar = array();
        foreach ($arParams as $code => $val) {
            if (is_array($val)) {
                if (isset($val[1]) && $val[1] == 'str') {
                    if (is_callable($val[2])) {
                        $val[0] = $val[2]($val[0]);
                    }
                    $val = "'$val[0]'";
                } else {
                    $val = $val[0];
                }
            }
            $proc_params_tmp_ar[] = $val;
        }
        return implode(", ", $proc_params_tmp_ar);
    }

    function detail_search()
    {
        $this->__unauth_redir();
        $this->load->library('pagination');
        $this->load->helper('url');
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');
        $this->meta['theme'] = $theme;
        $pagination_key = 'pagination_param';
        $per_page = 200;
        if (!isset($_SESSION[$pagination_key]['page_num']) || !$_SESSION[$pagination_key]['page_num'] < 1) {
            $_SESSION[$pagination_key]['page_num'] = 1;
        }
        $_SESSION[$pagination_key]['page_num'] = $this->uri->segment(3) ? $this->uri->segment(3) : $_SESSION[$pagination_key]['page_num'];
        $form_data = array(
            'ip' => $_REQUEST['ip_address'],
            'login' => $_REQUEST['login'],
            'user_name' => $_REQUEST['user_name'],
            'phone' => $_REQUEST['phone'],
            'sess_start' => $_REQUEST['sess_start'],
            'sess_end' => $_REQUEST['sess_end'],

        );
        $date_formated = array();
        foreach (array('sess_start', 'sess_end') as $date_time_code) {
            if (!$form_data[$date_time_code]) {
                $date_formated[$date_time_code] = '';
                continue;
            }
            $date = DateTime::createFromFormat('d.m.Y H:i', $form_data[$date_time_code]);
            $date_formated[$date_time_code] = $date->format('Y-m-d H:i:s');
        }
        $is_form_submited = false;
        foreach ($form_data as $val) {
            if (strlen($val) > 0) {
                $is_form_submited = true;
                break;
            }
        }
        $sql_attributes = 'SELECT * FROM web_get_user_attributes';
        $this->data['user_attributes'] = $this->ideco_db->cabQueryMulti($sql_attributes);
        if ($is_form_submited || count($_REQUEST['ATTRS']) > 0) {
            $needed_fields = array(
                "IDENTIFY",
                "USER_ID",
                "LOGIN",
                "IP",
                "HOST_IP",
                "SMS",
                "ATTRIB_CODE_1",
                "ATTRIB_VAL_1",
                "ATTRIB_CODE_2",
                "ATTRIB_VAL_2",
                "ATTRIB_CODE_3",
                "ATTRIB_VAL_3",
                "SESSION_START",
                "SESSION_END"
            );

            /*
            SUID numeric(18,0),
            VIEW_ID integer,
            IP_ADR varchar(15),
            LGN varchar(32),
            FIO varchar(128),
            SMS_NUM varchar(32),
            LIMIT_FROM integer,
            LIMIT_TO integer)
            */
            $get_attr_param = function ($num, $get_attr_id) {
                $attr_req = $_REQUEST['ATTR'];
                $attr_values = array_values($attr_req);
                $attr_keys = array_keys($attr_req);
                $num--;
                if ($get_attr_id > 0) {
                    $ret_val = intval($attr_keys[$num]);
                } else {
                    $ret_val = $attr_values[$num];
                }
                return $ret_val;
            };
            $f_white_to_percent = function ($val) {
                return str_replace(" ", "%", $val);
            };


            $proc_params_def = array(
                "SUID" => array($_SESSION['cab']['session_id'], 'str'),
                "VIEW_ID" => array($_SESSION['cab']['user_id'], 'int'),
                "IP_ADR" => array($form_data['ip'], 'str'),
                "LGN" => array($form_data['login'], 'str'),
                "FIO" => array($form_data['user_name'], 'str', $f_white_to_percent),
                "SMS_NUM" => array($form_data['phone'], 'str'),
                "SESSION_START" => array($date_formated['sess_start'], 'str'),
                "SESSION_END" => array($date_formated['sess_end'], 'str'),
                //1 attr
                "ATTRIB_ID_1" => $get_attr_param(1, 1),
                "ATTRIB_FILTER_VAL_1" => array($get_attr_param(1, 0), 'str'),
                //2 attr
                "ATTRIB_ID_2" => $get_attr_param(2, 1),
                "ATTRIB_FILTER_VAL_2" => array($get_attr_param(2, 0), 'str'),
                //2 attr
                "ATTRIB_ID_3" => $get_attr_param(3, 1),
                "ATTRIB_FILTER_VAL_3" => array($get_attr_param(3, 0), 'str'),
                "LIMIT_FROM" => $this->uri->segment(2) + 1,
                "LIMIT_TO" => $this->uri->segment(2) + $per_page,

            );
            $proc_params_cnt_str = $this->get_proc_params_str($proc_params_def, array(
                "LIMIT_FROM" => 1,
                "LIMIT_TO" => 10000
            ));


            $sql_cnt = 'SELECT COUNT(*) as CNT FROM (SELECT LOGIN FROM WEB_USER_FIND(' . $proc_params_cnt_str . '))';
            $result_cnt = $this->ideco_db->cabQueryMulti($sql_cnt);

            $result_cnt = $result_cnt[0]['CNT'];
            $this->data['cnt'] = $result_cnt;
            $config["base_url"] = base_url() . '/detail_search/';
            $config['first_url'] = $config['base_url'] . '?' . http_build_query($_GET);
            $config["total_rows"] = $result_cnt;
            $config["per_page"] = 200;
            $config["uri_segment"] = 2;
            $config['last_link'] = 'В конец';
            $config['first_link'] = 'В начало';
            $config['num_links'] = 10;
            if (count($_GET) > 0) $config['suffix'] = '?' . http_build_query($_GET, '', "&");
            $this->pagination->initialize($config);
            $proc_params_str = $this->get_proc_params_str($proc_params_def);
            $sql = 'SELECT ' . implode(", ", $needed_fields) . ' FROM WEB_USER_FIND(' . $proc_params_str . ')';
            $result = $this->ideco_db->cabQueryMulti($sql);
            $this->data['user_search'] = $result;

        }
        $this->data['is_submited'] = $is_form_submited;
        $this->data['form'] = $form_data;
        $this->load->view("$view/../cabinet/html_start", $this->meta);
        $this->load->view("$view/../cabinet/detail_search", $this->data); //
        $this->load->view("$view/../cabinet/html_end", $this->meta);
    }


    public function detail_user($user_id)
    {
        $this->__unauth_redir();
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');
        $this->meta['theme'] = $theme;
        if ($user_id < 1) {
            die('erorr!');
        }
        $sql = 'SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $user_id . ', null)';
        $result = $this->ideco_db->cabQueryMulti($sql);
        $result[0]['PASSPORT_CONNECT_ADDRESS'] = str_replace(", ,", ",", $result[0]['PASSPORT_CONNECT_ADDRESS']);
        $this->data['user'] = $result[0];
        $this->data['user']['USER_ID'] = $user_id;
        $this->data['fields'] = array(
            "IDENTIFY" => "Имя",
            "PASSPORT_SERIES" => "Cерия паспорта",
            "PASSPORT_NUMBER" => "Номер паспорта",
            "PASSPORT_PROPISKA" => "Прописка",
            "PASSPORT_ISSUE_DATE" => "Дата выдачи",
            "PASSPORT_PLACE_OF_ISSUE" => "Кем выдан",
            "PASSPORT_BIRTH_DATE" => "Дата рождения",
            "PASSPORT_CONNECT_ADDRESS" => "Адрес подключения",
        );


        $this->load->view("$view/../cabinet/html_start", $this->meta);
        $this->load->view("$view/../cabinet/detail_user", $this->data); //
        $this->load->view("$view/../cabinet/html_end", $this->meta);
    }


    function logout()
    {
        unset($_SESSION['cab']);
        header('Location: ' . "http://{$_SERVER['HTTP_HOST']}");
        $this->__redirect2https();
    }

    function userinfo()
    {
        $suid = $_SESSION['cab']['session_id'];
        $this->cabinet['cur_tab'] = 'userinfo';
        $this->__unauth_redir();
//Определяем view_id (ID просматриваемого пользователя)
        $uid_for_view = false;
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() >= 3) {
            $view_id = (int)$this->uri->rsegment(3, 1);
            $uid_for_view = $view_id;
        }
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        $this->data['show_helpdesk_link'] = false;
        $show_helpdesk = $this->ideco_db->get_vpn_const($suid, '56');
        if ($show_helpdesk && $_SESSION['cab']['isadmin'] == 1 && $uid_for_view) {
            // SHOW HELPDESK LINKS
            $this->data['show_helpdesk_link'] = true;
            $this->data['uid_for_view'] = $uid_for_view;
        } else {
            // Smotrim ne usera =(
        }
//Если пришел запрос на перевод денег
        $user_ip = $_SERVER['REMOTE_ADDR'];

        $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');

        $this->data['webauth'] = $this->ideco_db->cabQuerySingle("SELECT ID, NAME, LOGIN, LOGGED, AUTH_TYPE FROM WEB_GET_USER_BY_IP('{$user_ip}')");

        $this->data['messages'] = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_USER_MSGGET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
        $addons = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_USER_USLUGA_LIST(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ')');
        $this->data['addtelev'] = array();
        $ids_for_delete = array(); // этот массив надо если процедуры надо будет сортировать по таблица, пока есть два массива , по этому все просто - дальше сортировка будет проше , а главное всего один запрос к БД
        for ($i = 0; $i < count($addons); $i++) {
            if ($addons[$i]['SYSTEM_TYPE'] == 7) {
                $this->data['addtelev'][] = $addons[$i];
                $ids_for_delete[] = $i;
            }
        }
        foreach ($ids_for_delete as $id) {
            array_splice($addons, $id, 1);
        }
        $this->data['addons'] = $addons;
        if ($_SESSION['cab']['isadmin'] == 1) {
            $this->data['users'] = $this->ideco_db->cabQueryMulti('SELECT id,identify,balance from WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', null, ' . $view_id . ')');
            $this->data['tree'] = $this->ideco_db->cabQueryMulti('SELECT * FROM web_tree_get(' . $_SESSION['cab']['session_id'] . ', ' . $_SESSION['cab']['group_id'] . ', ' . $view_id . ')');
        }
        if ($this->ideco_cab->cabRequest('submit_promise')) {
            $sql = 'SELECT * FROM  WEB_USER_PROMISE_PAY(' . $suid . ',' . $view_id . ',NULL,\'' . $_SERVER['REMOTE_ADDR'] . '\')';
            $promise = $this->ideco_db->cabQuerySingle($sql);
            $this->data['result'] = 'Обещанный платеж:' . $promise['MSG'];
        }
        $this->data['content'] = '';
//	$this->data['db_error']=$this->ideco_db->db_error;
// Возможность менять MAC-адрес через ЛК
        if ($this->ideco_cab->cabRequest('mac_change')) {
            $sql = 'EXECUTE PROCEDURE WEB_USERS_MAC_CHANGE(' . $view_id . ', ' . $suid . ')';
            $this->ideco_db->cabQuerySingle($sql);
            $this->data['result'] = 'Процедура смены привязки MAC-адреса займёт не более 10 минут';
        }
        $this->data['mac_change'] = $this->ideco_db->get_vpn_const($suid, 67);

        $sql = 'SELECT * FROM WEB_PROMISE_ALLOW(' . $suid . ',' . $view_id . ')';
        $this->data['web_promise'] = $this->ideco_db->cabQuerySingle($sql);

        $days_in_month = cal_days_in_month(0, intval(date('m')), intval(date('Y')));
        $days = round($this->data['user']['BALANCE'] / ($this->data['user']['ABON_PAY'] / $days_in_month));
        $this->data['balance_until'] = date('d.m.Y', time() + $days * 24 * 60 * 60);
        $this->__show_page('userinfo');

    }

    function podpiska()
    {
        global $rentsoft_en;
        if ($rentsoft_en == 1) {
            $this->cabinet['cur_tab'] = 'podpiska';
            $this->__unauth_redir();
//Определяем view_id (ID просматриваемого пользователя)
            if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
                $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
            if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() >= 3)
                $view_id = (int)$this->uri->rsegment(3, 1);
            if ($view_id)
                $_SESSION['cab']['view_id'] = (int)$view_id;
//Если пришел запрос на перевод денег	
            $user_ip = $_SERVER['REMOTE_ADDR'];
            $filedata = file_get_contents('/cfg/fiscal.json');
            $ini_file = json_decode($filedata, true);
            $this->data['ag_name'] = $ini_file['rentsoft']['ag_name'][0];
            $this->data['ag_secret'] = $ini_file['rentsoft']['ag_secret'][0];
            $this->data['ag_address'] = $ini_file['rentsoft']['ag_ip'][0];
            $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
            $this->data['webauth'] = $this->ideco_db->cabQuerySingle("SELECT ID, NAME, LOGIN, LOGGED, AUTH_TYPE FROM WEB_GET_USER_BY_IP('{$user_ip}')");
            $this->data['messages'] = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_USER_MSGGET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
            $this->data['addons'] = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_USER_USLUGA_LIST(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ')');
            if ($_SESSION['cab']['isadmin'] == 1) {
                $this->data['users'] = $this->ideco_db->cabQueryMulti('SELECT id,identify,balance from WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', null, ' . $view_id . ')');
                $this->data['tree'] = $this->ideco_db->cabQueryMulti('SELECT * FROM web_tree_get(' . $_SESSION['cab']['session_id'] . ', ' . $_SESSION['cab']['group_id'] . ', ' . $view_id . ')');
            }
            $this->data['content'] = '';
//	$this->data['db_error']=$this->ideco_db->db_error;
            $this->__show_page('podpiska');
        } else {
            die("Page not found");
        }
    }

    function checkcard()
    {
        global $service;
        $ini_file = array();
        $ini_file = $this->parse_cfg();
        $this->cabinet['cur_tab'] = 'payment';
        parse_str($_SERVER['QUERY_STRING'], $_GET);
        $this->data['error'] = '';
        $this->data['result'] = '';
        ini_set('soap.wsdl_cache_enabled', '0');
        ini_set('soap.wsdl_cache_ttl', '0');
//$client = new SoapClient('/var/www/local/htdocs_ci/application/controllers/cabinet/WSDL/unitellerclient.wsdl',
        $uniteller_server = $ini_file['ecard']['server'][0];
        $client = new SoapClient("{$uniteller_server}/results/wsdl/",
            array('trace' => 0,
                'exceptions' => 1,
            )
        );
        $Order_ID = $_GET['Order_ID'];
// Настройки магазина
        $Shop_ID = $ini_file["ecard"]["sid"][0];
        $Shop_ID = substr($Shop_ID, 1, strlen($Shop_ID) - 2);
        $login = $ini_file["ecard"]["login"][0];
        $login = substr($login, 1, strlen($login) - 2);
        $password = $ini_file["ecard"]["password"][0];
        $password = substr($password, 1, strlen($password) - 2);
        $result = $client->GetPaymentsResult(
            $Shop_ID
            , $login
            , $password
            , $Order_ID
            , $success = 1
            , $startmin = null
            , $starthour = null
            , $startday = null
            , $startmonth = null
            , $startyear = null
            , $endmin = null
            , $endhour = null
            , $endday = null
            , $endmonth = null
            , $endyear = null
            , $meantype = null
            , $paymenttype = null
            , $english = null
        );
        $this->data['error'] = $result->Message;
// проверяем что запись об этой транзакции есть и сумма транзакции та,
// которая была указана на странице "корзина"
        if (count($result) == 1) {
//print_r($result);
            $this->data['result'] = iconv("utf-8", "windows-1251", $result[0]->recommendation);
            $this->data['obj_result'] = $result[0];
//$this->data['summ']=$result[0]->total;
//$this->data['date']=$result[0]->date;
// Транзакция выполнена
            $this->data['result_flag'] = '1';
        } else {
// Транзакция не выполнена
            $this->data['result_flag'] = '0';
        }
        $this->__show_page('checkcard');
    }

    function payment()
    {
        global $service;
        $this->cabinet['cur_tab'] = 'payment';
        $this->__unauth_redir();
//Определяем view_id (ID просматриваемого пользователя)
        $suid = $_SESSION['cab']['session_id'];
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
//Прараметры для отображения страницы 
        $ini_file = array();
        $ini_file = $this->parse_cfg();
        $qiwi_flag = $ini_file["qiwiwallet"]["enable"][0];
        $ecard_flag = $ini_file["ecard"]["enable"][0];
        $this->data['qiwi_enable'] = $qiwi_flag;
        $this->data['ecard_enable'] = $ecard_flag;
//активация карт оплаты
        $show_payment = $this->ideco_db->get_vpn_const($suid, 65);
        $this->data['card_activation'] = $show_payment;
//получаем параметры для запроса в базу
        $id = $_SESSION['cab']['view_id'];
        $card_serie = $this->ideco_cab->cabRequest('card_serie', 'str', '');
        $card_code = $this->ideco_cab->cabRequest('card_code', 'str', '');
        $ip = $_SERVER['REMOTE_ADDR'];
        $this->data['error'] = '';
        $this->data['result'] = '';
        $this->data['card_serie'] = $card_serie;
        $this->data['card_code'] = $card_code;
        $userinfo = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $suid . ', ' . $id . ', null)');
        $robo_flag = $ini_file["robokassa"]["enable"][0];
        $this->data['robokassa_enable'] = $robo_flag;
        if ($this->ideco_cab->cabRequest('robo_pay')) {
// your registration data  
            $mrh_login = $ini_file["robokassa"]["login"][0];
            $mrh_pass1 = $ini_file["robokassa"]["passpharase"][0];
            $subtotal_p = $this->ideco_cab->cabRequest('Subtotal_P', 'str', '');
// order properties 
            $op_date = 'now';
            $sql = "SELECT * FROM WEB_ROBOKASSA_OPERATIONS_ADD('ADD', NULL,NULL,'{$id}','{$subtotal_p}','{$op_date}', '{$ip}',0,'{$suid}')";
            $payResult = $this->ideco_db->cabQuerySingle($sql);
            $inv_id = $payResult['OPERATION_ID_OUT']; // shop's invoice number
// (unique for shop's lifetime) 
            $inv_desc = 'Contract number ' . $userinfo['CONTRACT_NUMBER']; // invoice desc
            $out_summ = $this->ideco_cab->cabRequest('Subtotal_P', 'str', ''); // invoice summ
// build CRC value 
            $crc = md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1"); // build URL
            $url = "Location: https://merchant.roboxchange.com/Index.aspx?MrchLogin=$mrh_login&" . "OutSum=$out_summ&InvId=$inv_id&Desc=$inv_desc&SignatureValue=$crc";
//$this->data['error']=$url;
            header($url);
            exit(0);
        }
        if ($this->ideco_cab->cabRequest('card_submit')) {
            if (!preg_match('/^[0-9a-zA-Z_.-]{1,32}$/', $card_serie)) {
                $this->data['error'] = 'Не задана серия карты оплаты.';
            }
            if (!preg_match('/^[0-9a-zA-Z_.-]{1,32}$/', $card_code)) {
                $this->data['error'] = 'Не задан секретный код карты оплаты.';
            }
            if (!$this->data['error']) {
                $sql = "SELECT * FROM WEB_CARD_PAY('{$suid}', '{$id}', '{$card_serie}', '{$card_code}', '{$ip}')";
                $payResult = $this->ideco_db->cabQuerySingle($sql);
                $this->data['result'] = $payResult['MSG'];
                if ($payResult['RES'] != '0') {
                    $this->data['result'] = '';
                    $this->data['error'] = $payResult['MSG'];
                }
            }
        }
        $op_date = 'now';
        if ($this->ideco_cab->cabRequest('ecard_pay')) {
            $subtotal_p = $this->ideco_cab->cabRequest('Subtotal_P', 'str', '');
            $shop_idp = $ini_file["ecard"]["sid"][0];
            $password = $ini_file["ecard"]["password"][0];
            $lifetime = $ini_file["ecard"]["ttl"][0];
            $payResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_ECARD_OPERATIONS_ADD('ADD', NULL,NULL,'{$id}','{$subtotal_p}','{$op_date}', '{$ip}',0,'{$suid}')");
            $order_idp = $payResult['OPERATION_ID_OUT'];
            $url_return = "https://{$_SERVER['HTTP_HOST']}/cabinet/checkcard";
//$url_ok="https://{$_SERVER['HTTP_HOST']}/cabinet/checkcard";
//$url_no="https://{$_SERVER['HTTP_HOST']}/cabinet/payment";
            $signature = //strtoupper(md5($shop_idp . $order_idp . $subtotal_p . $lifetime . $id . $password));
                strtoupper(md5(md5($shop_idp) . '&' . md5($order_idp) .
                    '&' . md5($subtotal_p) . '&' . md5('') . '&' . md5('') .
                    '&' . md5($lifetime) . '&' . md5('') . '&' .
                    md5('') . '&' . md5('') . '&' . md5('') . '&' .
                    md5($password)));
            $i = md5($password);
            $uniteller_server = $ini_file['ecard']['server'][0];
            header("Location: {$uniteller_server}/pay/?Shop_IDP={$shop_idp}&Order_IDP={$order_idp}&Subtotal_P={$subtotal_p}&Lifetime={$lifetime}&URL_RETURN={$url_return}&Signature={$signature}");
            exit(0);
        }
        if ($this->ideco_cab->cabRequest('qiwi_pay')) {
            $phone_id = $this->ideco_cab->cabRequest('to', 'str', '');
            $sum_in = $this->ideco_cab->cabRequest('amount_rub', 'str', '') . '.' . $this->ideco_cab->cabRequest('amount_kop', 'str', '');
            $userinfo = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $suid . ', ' . $id . ', null)');
            $comment = 'Contract number ' . $userinfo['CONTRACT_NUMBER'];
            $lifetime = $ini_file["qiwiwallet"]["ttl"][0];
            $sms = $ini_file["qiwiwallet"]["sms"][0];
            $l = $ini_file["qiwiwallet"]["login"][0];
            define('LOGIN', $l);
            $p = $ini_file["qiwiwallet"]["password"][0];
            define('PASSWORD', $p);
            define('TRACE', 1);
            include("qiwi/IShopServerWSService.php");
            $service = new IShopServerWSService('/var/www/application/controllers/cabinet/qiwi/IShopServerWS.wsdl', array('location' => 'http://ishop.qiwi.ru/services/ishop', 'trace' => TRACE));
            $payResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_QIWI_OPERATIONS_ADD('ADD', NULL,'{$phone_id}','{$id}','{$sum_in}','{$op_date}', '{$ip}',0,'{$suid}')");
            $op_id = $payResult['OPERATION_ID_OUT'];
            $this->data['result'] = $payResult['MSG'];
            $rc = $this->createBill2($phone_id, $sum_in, $op_id, $comment, $lifetime, $sms);
            header("Location: https://w.qiwi.ru/setInetBill_utf.do?from={$l}&to={$phone_id}&summ={$sum_in}&txn_id={$op_id}&iframe=true");
            exit(0);
        }
        $this->data['content'] = '';
        $this->__show_page('payment');
    }

    /**
     * @param $txn_id - номер отменяемого счета
     **/
    function cancelBill($txn_id)
    {
        global $service;
// Формирует объект-запрос
        $params = new cancelBill();
        $params->login = LOGIN;
        $params->password = PASSWORD;
        $params->txn = $txn_id;
// вызываем метод сервиса с параметрами
        $res = $service->cancelBill($params);
// выводим результат
        print($res->cancelBillResult);
// для отладки (вывод тела запроса)
// print($service->__getLastRequest());
    }

    /**
     * @param $phone (string) - номер телефона (QIWI Кошелька), на который будет выставляться счет
     * @param $amount (string) - сумма к оплате (в формете "рубли"."копейки")
     * @param $txn_id (string) - номер счета (уникальная в пределах магазина)
     * @param $comment (string) - комментарий
     * @param $lifetime (string) - срок действия счета (в формате dd.mm.yyyy HH:MM:SS)
     * @param $alarm (int) - уведомление
     * @param $create (bool) - выставлять незарегистрированному пользователю
     **/
    function createBill2($phone, $amount, $txn_id, $comment, $lifetime = '', $alarm = 0, $create = true)
    {
        global $service;
        $params = new createBill();
        $params->login = LOGIN; // логин
        $params->password = PASSWORD; // пароль
        $params->user = $phone; // пользователь, которому выставляется счет
        $params->amount = '' . $amount; // сумма
        $params->comment = $comment; // комментарий
        $params->txn = $txn_id; // номер заказа
        $params->lifetime = $lifetime; // время жизни (если пусто, используется по умолчанию 30 дней)
// уведомлять пользователя о выставленном счете (0 - нет, 1 - послать СМС, 2 - сделать звонок)
// уведомления платные для магазина, доступны только магазинам, зарегистрированным по схеме "Именной кошелёк"
        $params->alarm = $alarm;
// выставлять счет незарегистрированному пользователю
// false - возвращать ошибку в случае, если пользователь не зарегистрирован
// true - выставлять счет всегда
        $params->create = $create;
        $res = $service->createBill($params);
        $rc = $res->createBillResult;
        return $rc;
    }

    function helpdesk()
    {
        $this->__unauth_redir();
        if ($_SERVER['HTTPS'] != '') {
            $proto = "https://";
        } else {
            $proto = "http://";
        }
        $url = $proto . $_SERVER['HTTP_HOST'] . '/cabinet/helpdesk/?id=';
        $this->cabinet['cur_tab'] = 'helpdesk';
        $id = intval($_GET['id']);
        $this->data['id'] = $id;
        $view_id = intval($_SESSION['cab']['view_id']);
        $this->data['hdsk_ticket_status'] = $this->hdsk_ticket_status;
        if ($_SESSION['cab']['isadmin']) {
            $view_id = intval($_SESSION['cab']['user_id']);
        }
        ($_SESSION['cab']['isadmin']) ? ($this->data['is_admin'] = true) : ($this->data['is_admin'] = false);
        if ($id == 0) {
            if ($_POST) {
                //Добавляем заяку
                $text = $_POST['text'];
                $status = intval($_POST['status']);
                $subj = $_POST['subj'];
                $text = htmlspecialchars($text);
                if ( /*trim($text) != '' && */
                    trim($subj) != ''
                ) {
                    $uid_for_store = $view_id;
                    if ($_SESSION['cab']['isadmin']) {
                        $uid_for_store = $_SESSION['cab']['hdsk_filter_id'];
                    }
                    $sql = "EXECUTE PROCEDURE  HDSK_TASK_EDIT({$uid_for_store},0,null,'{$subj}','{$text}',{$status},'{$url}')";
                    $this->ideco_db->cabQuerySingle($sql);
                    $this->data['hdsk_add_ok'] = true;
                    {
                        header('Location: ' . "{$proto}{$_SERVER['HTTP_HOST']}/cabinet/helpdesk/" . (($_GET['filter_id']) ? ('?filter_id=' . $_GET['filter_id']) : (''))); //Its possoble bugly code =(
                    }
                }
            } else {
                // просто открыли страницу
                $this->data['hdsk_add_ok'] = false;
            }
            // Выводим все остальное после главной формы заявки
            $filter_uid = ($_SESSION['cab']['isadmin'] ? 0 : $view_id);
            if ($_SESSION['cab']['isadmin'] && intval($_GET['filter_id']) > 0) {
                // Если юзера админ то можно фильтровать заявки по пользователю
                $filter_uid = intval($_GET['filter_id']);
                $_SESSION['cab']['hdsk_filter_id'] = $filter_uid;
                $this->data['hdsk_filter_id'] = $filter_uid;
                //die('['.$filter_uid.']');
            }
            $sql1 = 'SELECT  * FROM HDSK_TASK_LIST(' . $filter_uid . ',0)';
            $this->data['hdsk_open_list'] = $this->ideco_db->cabQueryMulti($sql1);
            $sql2 = 'SELECT * FROM HDSK_TASK_LIST(' . $filter_uid . ',10)';
            $this->data['hdsk_close_list'] = $this->ideco_db->cabQueryMulti($sql2);
        } else {
            // Показываем конкретную ветку
            $sql_get = "SELECT * FROM HDSK_TASK_GET({$id})";
            if (!$_SESSION['cab']['isadmin']) {
                //Если не админ то проверяем доступ к теме
                $data = $this->ideco_db->cabQuerySingle($sql_get);
                if ($data['O_UID'] != $view_id) die('ACCESS ERROR');
            }
            if ($_POST) // Так есть похоже данные для записи
            {
                $text = $_POST['text'];
                $subj = ' ';
                $text = htmlspecialchars($text);
                $status = intval($_POST['status']);
                $uk = 0;
                // только меняем статус
                if (trim($text) == '' || $_POST['status'] != '') {
                    $uk = 10;
                    if ($_SESSION['cab']['isadmin']) {
                        $status = intval($_POST['status']);
                    } else {
                        $status = 10;
                    }
                    $sql = "EXECUTE PROCEDURE  HDSK_TASK_EDIT({$view_id},{$uk},{$id},'{$subj}','{$text}',{$status},'{$url}')";
                    $this->ideco_db->cabQuerySingle($sql);
                    header('Location: ' . "{$proto}{$_SERVER['HTTP_HOST']}/cabinet/helpdesk/" . (($_GET['filter_id']) ? ('?filter_id=' . $_GET['filter_id']) : (''))); //Its possoble bugly code =(
                    exit;
                }
                // добавляем
                if (trim($text) != '' || $status != 0) {
                    $sql = "EXECUTE PROCEDURE  HDSK_TASK_EDIT({$view_id},{$uk},{$id},'{$subj}','{$text}',{$status},'{$url}')";
                    $this->ideco_db->cabQuerySingle($sql);
                    if ($_SESSION['cab']['isadmin']) {
                        // РРР eto admin - stavim tiketu status - 1 - ozhidanie otveta =)
                        $uk = 10;
                        $status = 1;
                        $sql = "EXECUTE PROCEDURE  HDSK_TASK_EDIT({$view_id},{$uk},{$id},'{$subj}','{$text}',{$status},'{$url}')";
                        $this->ideco_db->cabQuerySingle($sql);
                    }
                }
            }
            // Смотрим конкретную ветку заявок
            //die('['.$id.']');
            $this->data['hdsk_list'] = $this->ideco_db->cabQueryMulti($sql_get);
        }
        $this->__show_page('helpdesk');
    }

    function stat()
    {
        $this->cabinet['cur_tab'] = 'stat';
        $this->__unauth_redir();
        $suid = $_SESSION['cab']['session_id'];
        $this->data['months'] = array('', 'Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь');
// Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
// получаем пользователя
        $sql = 'SELECT * FROM WEB_USER_GET(' . $suid . ', ' . $view_id . ', null)';
        $this->data['user'] = $this->ideco_db->cabQuerySingle($sql);
// определяемся с параметрами для запроса статистики
        $id = $view_id;
//        if (!isset($_REQUEST['date_start']))
//            $show_ruleset = 1;
//        else
        $show_ruleset = (int)$this->uri->rsegment(6, $this->ideco_cab->cabRequest('show_ruleset', 'int', 0));
        $perpage = 10;
        $date_start = (string)$this->uri->rsegment(3, $this->ideco_cab->cabRequest('date_start', 'str', ''));
        $date_end = (string)$this->uri->rsegment(4, $this->ideco_cab->cabRequest('date_end', 'str', ''));
        $resolution = (int)$this->uri->rsegment(5, $this->ideco_cab->cabRequest('resolution', 'int', 4));
        if ($date_start == '' and $date_end == '') {
            $date_start = date('01.m.Y');
            $date_end = date('d.m.Y');
        }
        //echo $date_start.'--'. $date_end.'<br />';
        if (isset($_REQUEST['show_group_sum']))
            $show_group_sum = 1;
        else
            $show_group_sum = (int)$this->uri->rsegment(7, 0);
        $show_group_sum = abs($show_group_sum - 1);
        $nstart = (int)$this->uri->rsegment(8, 1);
        $nend = (int)$this->uri->rsegment(9, $nstart + $perpage - 1);
// передаем в шаблон русскую дату
        $this->data['date_start'] = $date_start;
        $this->data['date_end'] = $date_end;
// конвертим дату из русского формата в американский (для firebird)
        $ds_parts = explode('.', $date_start);
        $de_parts = explode('.', $date_end);
        $date_start = $ds_parts[2] . '-' . $ds_parts[1] . '-' . $ds_parts[0] . ' 00:00:00';
        $date_end = $de_parts[2] . '-' . $de_parts[1] . '-' . $de_parts[0] . ' 00:00:00';
        //echo $date_start.'--'. $date_end.'<br />';
        $date_start_int = strtotime($date_start);
        $date_end_int = strtotime($date_end);
        if (!$date_start_int) {
            $begin_date = mktime(0, 0, 0, intval(date('m')), 1, intval(date('Y')));
            $date_start_int = $begin_date;
        }
        if (!$date_end_int) {
            $end_date = mktime(0, 0, 0, intval(date('m')), 31, intval(date('Y')));
            $date_end_int = $end_date;
        }
        $begin_date_s = date('d.m.Y', strtotime($date_start));
        $end_date_s = date('d.m.Y', strtotime($date_end));
//        $cur_mnt = intval(date('m'));
// делаем огромную выборку, чтобы посчитать общее число записей в нашей статистике
//        $sql = 'SELECT COUNT(USER_ID) as TOTAL FROM WEB_USER_SESSIONS_GET(' . $suid . ', ' . $id . ', ' . $date_start . ', ' . $date_end . ', ' . $resolution . ', ' . $show_ruleset . ', ' . $show_group_sum . ', null, \'1\', \'10000\')';
        $sql = 'SELECT COUNT(ID) as TOTAL FROM TRAFFIC_GET(' . $id . ', ' . $begin_date . ', ' . $end_date . ')';
        $total = $this->ideco_db->cabTrafQuerySingle($sql);
        $this->data['total'] = $total['TOTAL'];
        $this->data['pages'] = ceil($this->data['total'] / $perpage);
        $this->data['nstart'] = $nstart;
        $this->data['perpage'] = $perpage;
        $this->data['page'] = ceil($nstart / $perpage);
// формируем запрос
//        $sql = 'SELECT * FROM WEB_USER_SESSIONS_GET(' . $suid . ', ' . $id . ', ' . $date_start . ', ' . $date_end . ', ' . $resolution . ', ' . $show_ruleset . ', ' . $show_group_sum . ', null, ' . $nstart . ', ' . $nend . ')';
//        $nstart--;
        $sql = 'SELECT first ' . $nend . ' skip ' . $nstart . ' * FROM  TRAFFIC_GET(' . $id . ', ' . $date_start_int . ', ' . $date_end_int . ')';
//        получаем статистику из базы и передаем в шаблон
        $this->data['stat'] = $this->ideco_db->cabTrafQueryMulti($sql);
// расходы
//        print '<pre>'; var_dump($_SESSION); print '</pre>';
        $sql = 'SELECT * FROM WEB_GET_COUNTERS(' . $suid . ', ' . $view_id . ', \'' . $begin_date_s . '\', \'' . $end_date_s . '\')';
        //$sql = 'SELECT * FROM WEB_GET_COUNTERS(' . $suid . ', ' . $view_id . ', ' . $begin_date . ', ' . $end_date . ')';
        //echo $sql;
        $this->data['razhod'] = $this->ideco_db->cabQueryMulti($sql);
        $sql = 'SELECT * FROM WEB_GET_PAY_LOG(' . $suid . ', ' . $view_id . ', \'' . $begin_date_s . '\', \'' . $end_date_s . '\')';
        $this->data['prihod'] = $this->ideco_db->cabQueryMulti($sql);
//        print $sql;
// передаем все оставшиеся параметры в шаблон
        $this->data['resolution'] = $resolution;
        $this->data['show_ruleset'] = $show_ruleset;
        $this->data['show_group_sum'] = abs($show_group_sum - 1);
        $this->data['content'] = '';
        $this->data['show_stat'] = $this->ideco_db->get_vpn_const($suid, '71');
        $this->__show_page('stat');
    }

    function audit()
    {
        $this->cabinet['cur_tab'] = 'audit';
        $this->__unauth_redir();
        if ($_SESSION['cab']['show_audit'] == 1) {
            $this->__unauth_redir();
        }
//Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
//получаем пользователя
        $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
//определяемся с параметрами для запроса статистики
        $suid = $_SESSION['cab']['session_id'];
        $id = $view_id;
        $perpage = 20;
//    $date_start         = $this->ideco_cab->cabRequest('date_start', 'str', date('01.m.Y'));
//    $date_end           = $this->ideco_cab->cabRequest('date_end', 'str', date('d.m.Y'));
//    $nstart             = $this->ideco_cab->cabRequest('nstart', 'int', 1);
        $date_start = (string)$this->uri->rsegment(3, $this->ideco_cab->cabRequest('date_start', 'str', date('01.m.Y')));
        $date_end = (string)$this->uri->rsegment(4, $this->ideco_cab->cabRequest('date_end', 'str', date('d.m.Y')));
//        $date_start         = (string)$this->uri->rsegment(3, date('01.m.Y'));
//        $date_end           = (string)$this->uri->rsegment(4, date('d.m.Y'));
        $nstart = (int)$this->uri->rsegment(5, 1);
        $nend = (int)$this->uri->rsegment(6, $nstart + $perpage - 1);
//передаем в шаблон русскую дату
        $this->data['date_start'] = $date_start;
        $this->data['date_end'] = $date_end;
//конвертим дату из русского формата в американский (для firebird)
        $ds_parts = explode('.', $date_start);
        $de_parts = explode('.', $date_end);
        $date_start = $ds_parts[2] . '-' . $ds_parts[1] . '-' . $ds_parts[0] . ' 00:00:00';
        $date_end = $de_parts[2] . '-' . $de_parts[1] . '-' . $de_parts[0] . ' 23:59:59';
//делаем огромную выборку, чтобы посчитать общее число записей в нашей статистике
        $sql = "SELECT COUNT(OP_ID) as TOTAL
            FROM WEB_AUDIT_GET('{$suid}', '{$date_start}','{$date_end}', '{$id}')";
        $total = $this->ideco_db->cabQuerySingle($sql);
        $this->data['total'] = $total['TOTAL'];
        $this->data['pages'] = ceil($this->data['total'] / $perpage);
        $this->data['nstart'] = $nstart;
        $this->data['perpage'] = $perpage;
        $this->data['page'] = ceil($nstart / $perpage);
//формируем запрос
//получаем статистику из базы и передаем в шаблон
        $sql = "SELECT FIRST {$perpage} SKIP " . ($nstart - 1) . " *
            FROM WEB_AUDIT_GET('{$suid}', '{$date_start}','{$date_end}', '{$id}')";
        $this->data['stat'] = $this->ideco_db->cabQueryMulti($sql);
        $this->data['content'] = '';
        $this->__show_page('audit');
    }

    function operations()
    {
        $this->cabinet['cur_tab'] = 'operations';
        $this->__unauth_redir();
        $suid = $_SESSION['cab']['session_id'];
//Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        if ($_POST) {
            $id = $_POST['id'];
            $sql = 'SELECT * from WEB_FIN_OPER(' . $suid . ', ' . $view_id . ') WHERE OP_ID=' . $id;
            $print_form = $this->ideco_db->cabQueryMulti($sql);
            $name = $print_form[0]['OP_NAME'] . '_' . $print_form[0]['OP_DATE_STR'] . '.pdf';
            header('Content-type: application/pdf');
            header('Content-Disposition: attachment; filename="' . $name . '"');
            echo $print_form[0]['PRINT_FORM'];
            die();
        }
// получаем пользователя
        $sql = 'SELECT * FROM WEB_USER_GET(' . $suid . ', ' . $view_id . ', null)';
        $this->data['user'] = $this->ideco_db->cabQuerySingle($sql);
// получаем список операций
        $sql = 'SELECT * from WEB_FIN_OPER(' . $suid . ', ' . $view_id . ')';
        $this->data['operations'] = $this->ideco_db->cabQueryMulti($sql);
        $this->data['content'] = '';
        $this->__show_page('operations');
    }

    function uservices()
    {
        $this->cabinet['cur_tab'] = 'uservices';
        $suid = $_SESSION['cab']['session_id'];
        $this->__unauth_redir();
// Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        if ($this->ideco_cab->cabRequest('submit_delete')) {
            $sql = 'EXECUTE PROCEDURE WEB_USER_USLUGA_DELETE(' . $suid . ', ' . $view_id . ', ' . intval($_POST['id']) . ')';
            $this->ideco_db->cabQuerySingle($sql);
        }
        //TODO: Удалить в контрол этот кусок , специальная логика для димы
        if ($this->ideco_cab->cabRequest('submit_addon')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $usluga_id = $this->ideco_cab->cabRequest('usluga_id', 'int', 0);
            $usluga_comment = $this->ideco_cab->cabRequest('usluga_comment', 'str', '');
            $changeResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_USR_USLUGA_ADD('{$suid}', '{$user_id}', '{$usluga_id}','{$usluga_comment}')");
            if (is_array($changeResult)) {
                $this->data['result'] = $changeResult['MSG'];
            } else {
                $this->data['result'] = $changeResult;
            }
        }
        // END TODO
        $sql = 'SELECT * FROM WEB_USER_USLUGA_LIST_AVAIL(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ')';
        $this->data['addons'] = $this->ideco_db->cabQueryMulti($sql);

        $sql = 'SELECT * FROM WEB_USER_SERVICES_GET(' . $suid . ', ' . $view_id . ')';
        $this->data['services'] = $this->ideco_db->cabQueryMulti($sql);
        $this->__show_page('uservices');
    }

    function documents()
    {
        $this->cabinet['cur_tab'] = 'documents';
        $this->data['result'] = '';
        $this->__unauth_redir();
        $suid = $_SESSION['cab']['session_id'];
        //Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        $sql = "select * from web_docs_get(${suid},${view_id});";
        $this->data['docs'] = $this->ideco_db->cabQueryMulti($sql);
        $this->data['content'] = '';
        $this->__show_page('documents');
    }

    function tarif()
    {
        $this->cabinet['cur_tab'] = 'tarif';
        $suid = $_SESSION['cab']['session_id'];
        $this->data['result'] = '';
        $this->__unauth_redir();
        //Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        //получаем пользователя
        $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
        //print 'SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)<br />';
        //print '<pre>'; print_r($this->data['user']); print '</pre>';
        //print 'SELECT * FROM WEB_TARIFF_GET2(null, ' . $view_id . ')';
        //получаем тарифный план
        $sql = 'SELECT * FROM WEB_USER_SERVICES_GET(' . $suid . ', ' . $view_id . ')';
        $this->data['tarif_uslugi'] = $this->ideco_db->cabQueryMulti($sql);
        //print '<pre>'; var_dump($uslugi); print $sql; print '</pre>';
        //Если пришел запрос на смену тарифа
        if ($this->ideco_cab->cabRequest('change_tarif')) {
            //получаем параметры запроса
            $id = $view_id;
            $new_plan_id = $this->ideco_cab->cabRequest('new_plan_id', 'int', 0);
            $ip = $_SERVER['REMOTE_ADDR'];
            //если указан id нового тарифа, производим смену
            if ($new_plan_id) {
                $sql = "SELECT * FROM WEB_USER_CHANGETARIFF('{$suid}', '{$id}', '{$new_plan_id}', '{$ip}')";
                //echo $sql;
                $changeResult = $this->ideco_db->cabQuerySingle($sql);
                if (is_array($changeResult)) {
                    $this->data['result'] = $changeResult['MSG'];
                } else {
                    $this->data['result'] = $changeResult;
                }
            }
        }

//получаем список тарифных планов, доступных для перехода
        $this->data['xml_tarlist'] = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_TARIFF_AVAIL_LIST(' . $view_id . ')');
        $this->data['content'] = '';
        $this->__show_page('tarif');
    }

    function control()
    {
        $this->cabinet['cur_tab'] = 'control';
        $this->data['result'] = '';
        $this->__unauth_redir();
        //Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        //Если пришел запрос на блокировку
        if ($this->ideco_cab->cabRequest('change_disabled')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $own_disabled = $this->ideco_cab->cabRequest('own_disabled', 'int', 0);
            $own_disabled_days = $this->ideco_cab->cabRequest('own_disabled_days', 'int', 1);
            $ip = $_SERVER['REMOTE_ADDR'];
            $changeResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_USER_OWN_DISABLED('{$suid}', '{$user_id}', '{$own_disabled}', '{$own_disabled_days}', '{$ip}')");
            if (is_array($changeResult)) {
                $this->data['result'] = $changeResult['MSG'];
            } else {
                $this->data['result'] = $changeResult;
            }
        }
        //Если пришел запрос на обещанный платеж
        if ($this->ideco_cab->cabRequest('change_promise')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $promise_pay = $this->ideco_cab->cabRequest('promise_pay', 'int', 0);
            $ip = $_SERVER['REMOTE_ADDR'];
            $sql = "SELECT * FROM WEB_USER_PROMISE_PAY('{$suid}', '{$user_id}', '{$promise_pay}', '{$ip}')";
            $changeResult = $this->ideco_db->cabQuerySingle($sql);
            if (is_array($changeResult)) {
                $this->data['result'] = $changeResult['MSG'];
            } else {
                $this->data['result'] = $changeResult;
            }
        }
        //TODO: Добавлю код со вкладкой услуги в дельнейшем удалить нафиг
        if ($this->ideco_cab->cabRequest('submit_addon')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $usluga_id = $this->ideco_cab->cabRequest('usluga_id', 'int', 0);
            $usluga_comment = $this->ideco_cab->cabRequest('usluga_comment', 'str', '');
            $changeResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_USR_USLUGA_ADD('{$suid}', '{$user_id}', '{$usluga_id}','{$usluga_comment}')");
            if (is_array($changeResult)) {
                $this->data['result'] = $changeResult['MSG'];
            } else {
                $this->data['result'] = $changeResult;
            }
        }
        // END TODO:
//Если пришел запрос на подключение номера
        if ($this->ideco_cab->cabRequest('submit_phone_pull')) {
//получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $phone_number = $this->ideco_cab->cabRequest('phone_number', 'int', 0);
            $sql = "SELECT * FROM WEB_USER_PHONE_ADD('{$suid}', '{$user_id}', '{$phone_number}')";
            $changeResult = $this->ideco_db->cabQuerySingle($sql);
            if (is_array($changeResult)) $this->data['result'] = $changeResult['MSG'];
            else  $this->data['result'] = $changeResult;
        }
        //Если пришел запрос на смену пароля
        if ($this->ideco_cab->cabRequest('change_pass')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $old_pass = $this->ideco_cab->cabRequest('old_pass', 'str', '');
            $new_pass = $this->ideco_cab->cabRequest('new_pass', 'str', '');
            $new_pass2 = $this->ideco_cab->cabRequest('new_pass2', 'str', '');
            $ip = $_SERVER['REMOTE_ADDR'];
            $error = '';
            if ($new_pass != $new_pass2) {
                $error = 'Пароли не совпали';
            }
            if (!trim($new_pass)) {
                $error = 'Нельзя установить пустой пароль';
            }
            if (!$error) {
                $changeResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_USER_PASSWORD('{$user_id}', '{$old_pass}', '{$new_pass}', '{$ip}',{$suid})");
                $this->data['result'] = $changeResult['RESULT'] == 1 ? 'Пароль успешно изменен' : 'Ошибка при смене пароля. Попробуйте позже.';
            } else {
                $this->data['result'] = $error;
            }
        }
        //Если пришел запрос на смену данных
        if ($this->ideco_cab->cabRequest('change_info')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $user_id = $view_id;
            $new_email = $this->ideco_cab->cabRequest('new_email', 'str', '');
            $sms = $this->ideco_cab->cabRequest('new_sms', 'str', '');
            $ip = $_SERVER['REMOTE_ADDR'];
            $changeResult = $this->ideco_db->cabQuerySingle("SELECT * FROM WEB_USER_CHANGEINFO('{$suid}', '{$user_id}', '{$new_email}', '{$sms}', '{$ip}')");
            $this->data['result'] = $changeResult['RESULT'] == 1 ? 'Данные успешно изменены' : 'Ошибка при смене адреса e-mail. Попробуйте позже.';
        }
        if ($this->ideco_cab->cabRequest('transfer_money')) {
            //получаем параметры запроса
            $suid = $_SESSION['cab']['session_id'];
            $id = $view_id;
            $ip = $_SERVER['REMOTE_ADDR'];
//	            $mtransfer_summ   = $this->ideco_cab->cabRequest('MTRANSFER_SUMM', 'int', 0);
//	            $mtransfer_login  = $this->ideco_cab->cabRequest('MTRANSFER_LOGIN', 'int', 0);
//	            $mtransfer_uid    = $this->ideco_cab->cabRequest('MTRANSFER_UID', 'int', 0);
//	            $mtransfer_agrnum = $this->ideco_cab->cabRequest('MTRANSFER_AGRNUM', 'int', 0);
//
            if ($this->ideco_cab->cabRequest('TRANSFER_SUMM', 'int', 0)) {
                $changeResult = $this->ideco_db->cabQuerySingle("SELECT result,msg
				    FROM WEB_USER_TRANSFERMOUNEY('{$suid}', '$view_id',
				         '{$this->ideco_cab->cabRequest('TRANSFER_SUMM', 'int', 0)}',
					 '{$this->ideco_cab->cabRequest('DST_LOGIN', 'str', '')}',
					 '{$this->ideco_cab->cabRequest('DST_USER_ID', 'int', 0)}',
					 '{$this->ideco_cab->cabRequest('DST_CONTRACT_NUMBER', 'str', '')}',
					 '{$this->ideco_cab->cabRequest('DST_IP', 'str', '')}',
					 '{$ip}')");
                $this->data['result'] = $changeResult['MSG'];
                if (ibase_errcode()) {
                    echo qwe;
                    $this->data['result'] = $this->ideco_db->dbException();
                }
            }
        }
        //получаем пользователя
        $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
        $sql = 'SELECT * FROM WEB_USER_TARIFF_OPTIONS(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ')';
        $this->data['tarif_options'] = $this->ideco_db->cabQuerySingle($sql);
        $suid = $_SESSION['cab']['session_id'];
        $this->data['password_change'] = $this->ideco_db->get_vpn_const($suid, '66');
        //Получаем доп.услуги
        $this->data['addons'] = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_USER_USLUGA_LIST_AVAIL(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ')');
//Получаем список доступных для выбора телефонных номеров, если услуга заказана но телефонный номер еще не присвоен
        $phone_pull = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_USER_PHONE_LIST(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', 10 )');
        if (count($phone_pull) > 0) {
            $this->data['phone_pull'] = $phone_pull;
        }

        $this->data['content'] = '';
//возможность смены пароля
        $this->__show_page('control');
    }

    function sysmon()
    {
        $this->cabinet['cur_tab'] = 'sysmon';
        $this->data['result'] = '';
        $this->data['xml_file'] = '';
        $this->__unauth_redir();
        if ($_SESSION['cab']['isadmin'] != 1) {
            header('Location: ' . "http://{$_SERVER['HTTP_HOST']}/cabinet/");
            $this->__redirect2https();
        }
//Определяем view_id (ID просматриваемого пользователя)
        if (isset($_SESSION['cab']['view_id']))
            $view_id = $_SESSION['cab']['view_id'];
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() > 2)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        $this->data['user'] = $this->ideco_db->cabQuerySingle('SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)');
//подготавливаем параметры
        $suid = $_SESSION['cab']['session_id'];
        $mode = (string)$this->uri->rsegment(3, 'sysstate');;
        $msg_type = rand(1111, 9999);
        $msg_array = array("top", "sysstate", "squid", "iptraf", "mrtg");
        $msg_sent = false;
//если скрипту передан корректный режим просмотра
        if (in_array($mode, $msg_array)) {
            $msg_id = msg_get_queue(0x2001);
//формируем текст сообщения для демона
            $msg_text = ($mode == "mrtg" ? "$msg_type mrtg $suid" : "$msg_type " . $mode);
            $this->data['msg_text'] = $msg_text;
//отправляем сообщение
            msg_send($msg_id, 1, "$msg_text", false, false, $err);
            $msg_sent = true;
        }
//если сообщение демону было отправлено
        if ($msg_sent) {
            $stop_waiting = false;
            $iterations = 0;
            @unlink('/tmp/tmpfs/tmp_xml/sysmon.xml');
//крутим цикл до тех пор пока не придет ответ от демона
            while (!$stop_waiting) {
                sleep(2);
                $stop_waiting = msg_receive($msg_id, $msg_type, $rcvd_msgtype, 44, $data, false);
            }
//теперь читаем сгенерированный xml-файл
            if ($mode != 'mrtg') {
                while (!@sizeof($xml_file))
                    $xml_file = file_get_contents('/tmp/tmpfs/tmp_xml/sysmon.xml');
            }
            @unlink('/tmp/tmpfs/tmp_xml/sysmon.xml');
            if (!isset($xml_file))
                $xml_file = '';
            $this->data['xml_file'] = $xml_file;
        }
        $this->data['mode'] = $mode;
        $this->data['content'] = '';
        $this->__show_page('sysmon');
    }

    function get_op_id()
    {
        $op_id_sql = 'SELECT NEXT VALUE FOR VIDIMAX_OPERATION_ID FROM RDB$DATABASE;';
        $operationId = $this->ideco_db->cabQuerySingle($op_id_sql);
        return $operationId;
    }

    function vidimax()
    {
        global $ini_file;
        $this->cabinet['cur_tab'] = 'vidimax';
        $this->__unauth_redir();
// Определяем view_id (ID просматриваемого пользователя)
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() >= 3)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
// ID пользователя
        $sql = 'SELECT * FROM WEB_USER_GET(' . $_SESSION['cab']['session_id'] . ', ' . $view_id . ', null)';
        $this->data['user'] = $this->ideco_db->cabQuerySingle($sql);
        $customerId = $this->data['user']["LOGIN"];
// ID операции
        $operationId = $this->get_op_id();
// Соль
        $operatorSecret = $ini_file['vidimax']['operator_secret'][0];
// хэш для запросов
        $md5sum = md5('customerId:' . $customerId . ',operationId:' . $operationId . '{' . $operatorSecret . '}');
// смена тарифа
        $this->data['change_package_result'] = -1;
        if ($this->ideco_cab->cabRequest('change_package')) {
            $newTariffId = $_POST['newTariffId'];
            $request_url = 'https://oss.vidimax.ru:8444/api/5.0/subscribe?operationId=' . $operationId . '&customerId=' . $customerId . '&newTariffId=' . $newTariffId . '&sign=' . $md5sum;
            $result = json_decode(file_get_contents($request_url));
            if ($result['resultCode'] = 0)
                $this->data['change_package_result'] = 1;
            else {
                $this->data['change_package_result'] = 0;
                $this->data['change_package_message'] = $result['resultMessage'];
            }
        }
// получаем список пакетов с vidimax
        $request_url = 'https://oss.vidimax.ru:8444/api/5.0/listTariffs?operationId=' . $operationId . '&customerId=' . $customerId . '&sign=' . $md5sum;
        $packages = json_decode(file_get_contents($request_url));
        if (!$packages['resultCode'])
            $this->data['get_packages'] = $packages['tariffList'];
        else {
            $this->data['get_packages_result'] = false;
            $this->data['get_packages_message'] = $packages['resultMessage'];
        }
// получаем текущий пакет пользователя с vidimax
        $request_url = 'https://oss.vidimax.ru:8444/api/5.0/getActiveTariff?operationId=' . $operationId . '&customerId=' . $customerId . '&sign=' . $md5sum;
        $package = json_decode(file_get_contents($request_url));
        if (!$package['resultCode'])
            $this->data['get_package'] = $package;
        else {
            $this->data['get_package_result'] = false;
            $this->data['get_package_message'] = $package['resultMessage'];
        }
        $this->__show_page('vidimax');
    }

    function reports()
    {
        $this->cabinet['cur_tab'] = 'reports/voip';
        $this->__unauth_redir();
//Определяем view_id (ID просматриваемого пользователя)
        if (!isset($_SESSION['cab']['view_id']) or !isset($view_id))
            $view_id = $_SESSION['cab']['isadmin'] ? $_SESSION['cab']['group_id'] : $_SESSION['cab']['id'];
        if ($_SESSION['cab']['isadmin'] == 1 && $this->uri->total_rsegments() >= 3)
            $view_id = (int)$this->uri->rsegment(3, 1);
        if ($view_id)
            $_SESSION['cab']['view_id'] = (int)$view_id;
        $user_ip = $_SERVER['REMOTE_ADDR'];
        $suid = $_SESSION['cab']['session_id'];
        $mode = (string)$this->uri->rsegment(3, 'newusers');
//получаем параметры для запроса в базу
        $suid = $_SESSION['cab']['session_id'];
        $id = $_SESSION['cab']['view_id'];
        $sd = date('01.m.Y', strtotime('-1 month'));
        $ed = date('t.m.Y', strtotime('-1 month'));
        $this->data['from'] = $sd;
        $this->data['to'] = $ed;
        if ($mode == 'newusers' or $mode == 'tarifs' or $mode == 'payments' or $mode == 'voip') {
            $this->data['content'] = '';
            $this->data['mode'] = $mode;
            if ($_POST and $mode == 'voip') {
                $abon = $this->ideco_cab->cabRequest('abon', 'str', '');
                $wis = "";
                if ($abon) {
                    $abon_list = explode(",", $abon);
                    if (count($abon_list) > 1) {
                        $abon_list_str = "(";
                        foreach ($abon_list as $a) {
                            $abon_list_str = $abon_list_str . "'" . strtoupper(trim($a)) . "',";
                        }
                        $abon_list_str = substr($abon_list_str, 0, -1) . ")";
                        $wis = " and (upper(login) in ${abon_list_str} or upper(contract_number) in ${abon_list_str} or user_id in ${abon_list_str} or src in ${abon_list_str})";
                    } else {
                        $wis = " and (upper(login)=upper('${abon}') or upper(contract_number)=upper('${abon}') or user_id='${abon}' or src='${abon}')";
                    }
                }
                $sql = "SELECT user_id, user_name, src, sum(bill_sum) as all_sum, sum(bill_sec) as all_time"
                    . " FROM WEB_REPORTS_VOIP_INFO(${suid}, ${id}, 'voip_json', '${sd}', '${ed}')"
                    . " WHERE bill_sum > 0" . $wis
                    . " GROUP BY user_id, user_name, src";
                try {
                    $abons = $this->ideco_db->cabQueryMulti($sql);
                } catch (Exception $e) {
                    print($sql);
                    print_r($e);
                    exit();
                }
                $sql = "SELECT e_time, dst, direction, bill_sec, bill_sum, user_id, step"
                    . " FROM WEB_REPORTS_VOIP_INFO(${suid}, ${id}, 'voip_json', '${sd}', '${ed}')"
                    . " WHERE bill_sum > 0" . $wis;
                try {
                    $rs = $this->ideco_db->cabQueryMulti($sql);
                } catch (Exception $e) {
                    print($sql);
                    print_r($e);
                    exit();
                }
                require_once 'tcpdf_include.php';
                $pdf = new TCPDF('L', 'mm', 'A4', true, 'UTF-8', false);
                $pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
                $pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
                $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
                $pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
                $pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
                $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
                if (@file_exists('/usr/local/lib/tcpdf/lang/rus.php')) {
                    require_once('/usr/local/lib/tcpdf/lang/rus.php');
                    $pdf->setLanguageArray($l);
                }
                $pdf->SetFont('freesans', '', 12);
                $header = array('Дата и время', 'Набранный номер', 'Направление', 'Мин', 'Стоимость');
                $interval = "${sd} - ${ed}";
                foreach ($abons as $abon) {
                    $rs1 = array();
                    $sum_min = 0;
                    $sum_rub = 0;
                    foreach ($rs as $row) {
                        if ($row['USER_ID'] == $abon['USER_ID']) {
                            $rs1[] = array(
                                'E_TIME' => $row['E_TIME'],
                                'DST' => $row['DST'],
                                'DIRECTION' => $row['DIRECTION'],
                                'BILL_SEC' => ceil($row['BILL_SEC'] / $row['STEP']),
                                'BILL_SUM' => $row['BILL_SUM']
                            );
                            $sum_min = $sum_min + ceil($row['BILL_SEC'] / $row['STEP']);
                            $sum_rub = $sum_rub + $row['BILL_SUM'];
                        }
                    }
                    $rs1[] = array(
                        'E_TIME' => 'Итого',
                        'DST' => '',
                        'DIRECTION' => '',
                        'BILL_SEC' => $sum_min,
                        'BILL_SUM' => $sum_rub
                    );
                    $data = $rs1;
                    $pdf->AddPage();
                    $pdf->Cell(0, 10, 'Детализация платных телефонных разговоров', 0, 0, 'L');
                    $pdf->Ln(10);
                    $pdf->Cell(0, 10, 'Абонент: ' . $abon['USER_NAME'], 0, 0, 'L');
                    $pdf->Ln(10);
                    $pdf->Cell(0, 10, 'Период: ' . $interval, 0, 0, 'L');
                    $pdf->Ln(20);
                    $pdf->BasicTable($header, $data);
                }
                $pdfname = $interval . '.pdf';
                $pdf->Output($pdfname, 'D');
                exit;
            }
            $this->__show_page('reports');
        } else {
//Подключаем модуль для JSON преобразования
            require_once(APPPATH . 'helpers/JSON.php');
//Общие параметры при работе с табличкой
            $page = $this->ideco_cab->cabRequest('page', 'str', '1'); // get the requested page
            $limit = $this->ideco_cab->cabRequest('rows', 'str', '10000'); // get how many rows we want to have into the grid
            $sord = $this->ideco_cab->cabRequest('sord', 'str', 'asc'); // get the direction
            $sd = $this->ideco_cab->cabRequest('from', 'str', $sd); // get the direction
            $ed = $this->ideco_cab->cabRequest('to', 'str', $ed); // get the direction
            $s_name = $this->ideco_cab->cabRequest('searchField', 'str', '');
            $s_value = iconv("utf-8", "windows-1251", $this->ideco_cab->cabRequest('searchString', 'str', '0'));
            $s_op = $this->ideco_cab->cabRequest('searchOper', 'str', '');
            $tqx = $this->ideco_cab->cabRequest('tqx', str, '');
            $data_format = $this->ideco_cab->cabRequest('df', str, 'jgrid');
            $reqID = substr($this->ideco_cab->cabRequest('tqx', str, 'reqID:0'), 6);
            switch ($s_op) {
                case 'eq':
                    $s_op = '=';
                    break;
                case 'cn':
                    $s_op = 'like';
                    $s_value = '%' . $s_value . '%';
                    break;
                case 'ne':
                    $s_op = '<>';
                    break;
                case 'nc':
                    $s_op = 'not like';
                    break;
                case 'lt':
                    $s_op = '<';
                    break;
                case 'le':
                    $s_op = '<=';
                    break;
                case 'gt':
                    $s_op = '>';
                    break;
                case 'ge':
                    $s_op = '>=';
                    break;
            }
            $wis = "";
            if ($s_name) {
                $wis = "where " . $s_name . " " . $s_op . " '" . $s_value . "' ";
            }
            if ($mode == 'tarifs_json' or $mode == 'tarifs_json_chart') {
                $sidx = $this->ideco_cab->cabRequest('sidx', 'str', 'PLAN_NAME'); // get index row - i.e. user click to sort
                $proc = 'WEB_REPORTS_TARIFS_INFO';
            }
            if ($mode == 'newusers_json' or $mode == 'newusers_json_chart') {
                $sidx = $this->ideco_cab->cabRequest('sidx', 'str', 'REG_YEAR'); // get index row - i.e. user click to sort
                $proc = 'WEB_REPORTS_NEWUSER_LIST';
            }
            if ($mode == 'payments_json_chart_trf' or $mode == 'payments_json_chart') {
                $sidx = $this->ideco_cab->cabRequest('sidx', 'str', 'OPERATOR_NAME'); // get index row - i.e. user click to sort
                $proc = 'WEB_REPORTS_PAYMENTS_INFO';
            }
            if ($mode == 'voip_json' or $mode == 'voip_json_chart') {
                $sidx = $this->ideco_cab->cabRequest('sidx', 'str', 'ID'); // get index row - i.e. user click to sort
                $proc = 'WEB_REPORTS_VOIP_INFO';
            }
            $sql = "SELECT count(*) as cnt from " . $proc . "(" . $suid . ", " . $id . ",'" . $mode . "', '" . $sd . "', '" . $ed . "')" . $wis;
            $rs = $this->ideco_db->cabQuerySingle($sql);
            $count = $rs['CNT'];
            if (!$limit) {
                $limit = $count;
            }
            if ($count > 0) {
                $total_pages = ceil($count / $limit);
            } else {
                $total_pages = 0;
            }
            if ($page > $total_pages)
                $page = $total_pages;
            $start = $limit * $page - $limit; // do not put $limit*($page - 1)
            if ($start < 0) {
                $start = 0;
            }
            $sql = "SELECT FIRST " . $limit . " SKIP " . $start . " * FROM " . $proc . "(" . $suid . ", " . $id . ", '" . $mode . "', '" . $sd . "', '" . $ed . "')" . $wis . " ORDER BY " . $sidx . " " . $sord;
            $rs = $this->ideco_db->cabQueryMulti($sql);
            setlocale(LC_ALL, 'ru_RU.UTF-8');
            $i = 0;
            if ($mode == 'newusers_json_chart') {
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Year";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "string";
                for ($i = 1; $i <= 12; $i++) {
                    $table->cols[$i]['id'] = "";
                    $table->cols[$i]['label'] = strftime('%b', mktime(0, 0, 0, $i, 1, 2011));
                    $table->cols[$i]['pattern'] = "";
                    $table->cols[$i]['type'] = "number";
                }
                $i = 0;
                foreach ($rs as $row) {
                    $table->rows[$i]['c'] = array(
                        array("v" => $row['REG_YEAR'], "f" => null),
                        array("v" => $row['JAN'], "f" => null),
                        array("v" => $row['FEB'], "f" => null),
                        array("v" => $row['MAR'], "f" => null),
                        array("v" => $row['APR'], "f" => null),
                        array("v" => $row['MAY'], "f" => null),
                        array("v" => $row['JUN'], "f" => null),
                        array("v" => $row['JUL'], "f" => null),
                        array("v" => $row['AUG'], "f" => null),
                        array("v" => $row['SEP'], "f" => null),
                        array("v" => $row['OCT'], "f" => null),
                        array("v" => $row['NOV'], "f" => null),
                        array("v" => $row['DECC'], "f" => null));
                    $i++;
                }
            }
            if ($mode == 'newusers_json') {
                $responce->page = $page;
                $responce->total = $total_pages;
                $responce->records = $count;
                foreach ($rs as $row) {
                    $responce->rows[$i]['id'] = $i;
                    $responce->rows[$i]['cell'] = array(
                        $row['REG_YEAR'],
                        strftime('%b', mktime(0, 0, 0, $row['REG_MONTH'], 1, 2011)),
                        $row['REG_DATE'],
                        iconv("windows-1251", "utf-8", $row['TARIF']),
                        iconv("windows-1251", "utf-8", $row['STATUS']),
                        $row['USR_AMOUNT']
                    );
                    $i++;
                }
            }
            if ($mode == 'tarifs_json') {
                $responce->page = $page;
                $responce->total = $total_pages;
                $responce->records = $count;
                foreach ($rs as $row) {
                    $responce->rows[$i]['id'] = $i;
                    $responce->rows[$i]['cell'] = array(
                        iconv("windows-1251", "utf-8", $row['PLAN_NAME']),
                        iconv("windows-1251", "utf-8", $row['USR_NAME']),
                        $row['USR_OSTATOK'],
                        iconv("windows-1251", "utf-8", $row['USR_ENABLED'])
                    );
                    $i++;
                }
            }
            if ($mode == 'tarifs_json_chart') {
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Tarif";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "string";
                $i++;
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Count";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "number";
                $i = 0;
                foreach ($rs as $row) {
                    $table->rows[$i]['c'] = array(
                        array("v" => iconv("windows-1251", "utf-8", $row['PLAN_NAME']), "f" => null),
                        array("v" => $row['USR_CNT'], "f" => null));
                    $i++;
                }
            }
            if ($mode == 'payments_json_chart') {
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Operator";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "string";
                $i++;
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Money";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "number";
                $i = 0;
                foreach ($rs as $row) {
                    $table->rows[$i]['c'] = array(
                        array("v" => iconv("windows-1251", "utf-8", $row['OPERATOR_NAME']), "f" => null),
                        array("v" => $row['SUM_OP_SUMMA'], "f" => null));
                    $i++;
                }
            }
            if ($mode == 'payments_json_chart_trf') {
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Plan_name";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "string";
                $i++;
                $table->cols[$i]['id'] = "";
                $table->cols[$i]['label'] = "Sum_session_credit";
                $table->cols[$i]['pattern'] = "";
                $table->cols[$i]['type'] = "number";
                $i = 0;
                foreach ($rs as $row) {
                    $table->rows[$i]['c'] = array(
                        array("v" => iconv("windows-1251", "utf-8", $row['PLAN_NAME']), "f" => null),
                        array("v" => $row['SUM_SESSION_CREDIT'], "f" => null) //,
//                        strftime('%b', mktime(0, 0, 0, $row['MONTH_IN'], 1, 2011))
                    );
                    $i++;
                }
            }
            setlocale(LC_ALL, 'ru_RU.UTF-8');
            $i = 0;
            if ($mode == 'voip_json') {
                $responce->page = $page;
                $responce->total = $total_pages;
                $responce->records = $count;
                foreach ($rs as $row) {
                    $responce->rows[$i]['id'] = $i;
                    $responce->rows[$i]['cell'] = array(
                        $row['SRC'],
                        $row['DST'],
                        $row['DIRECTION'],
                        $row['S_TIME'],
                        $row['E_TIME'],
                        $row['CHAN'],
                        $row['USER_ID'],
                        $row['DURATION'],
                        number_format($row['BILL_SEC'], 2, '.', ''),
                        number_format($row['BILL_SUM'], 2, '.', ''),
                        $row['CURRECY']
                    );
                    $i++;
                }
            }
            if ($data_format == 'google') {
                if ($tqx == 'out:csv;') {
                    $cvs = $this->array_to_cvs($rs);
                    header("Pragma: public");
                    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
                    header("Content-Type: text/csv");
                    header("Content-Description: File Transfer");
                    header("Content-Disposition: attachment; filename=" . $mode . ".csv");
                    print_r($cvs);
                    exit();
                }
                $responce->reqId = $reqID;
                $responce->status = "ok";
                $responce->sig = md5($sd + $sf);
                $responce->table = $table;
                echo "google.visualization.Query.setResponse(";
                //echo "handleQueryResponse(";
                $json = new Services_JSON();
                echo $json->encode($responce);
                echo ")";
            } else {
                $json = new Services_JSON();
                echo $json->encode($responce);
            }
            exit();
        }
    }

    function array_to_cvs($array, $header_row = true, $col_sep = ",", $row_sep = "\n", $qut = '"')
    {
        if (!is_array($array) or !is_array($array[0]))
            return false;
        //Header row.
        if ($header_row) {
            foreach ($array[0] as $key => $val) {
                //Escaping quotes.
                $key = str_replace($qut, "$qut$qut", $key);
                $output .= "$col_sep$qut$key$qut";
            }
            $output = substr($output, 1) . "\n";
        }
        //Data rows.
        foreach ($array as $key => $val) {
            $tmp = '';
            foreach ($val as $cell_key => $cell_val) {
                //Escaping quotes.
                $cell_val = str_replace($qut, "$qut$qut", $cell_val);
                $tmp .= "$col_sep$qut$cell_val$qut";
            }
            $output .= substr($tmp, 1) . $row_sep;
        }
        return $output;
    }
}
