################################################################
# Copyright © 2005 - 2019 CarbonSoft.
# All rights reserved.
# Site: https://www.carbonsoft.ru.
################################################################

<?php

class Detstat extends CI_Controller
{

    var $meta = array();
    var $data = array();

    public function __construct()
    {
        parent::__construct();
        Error_Reporting(E_ALL & ~E_NOTICE & ~E_WARNING);

        $this->meta['title'] = '';
        $this->meta['keywords'] = '';
        $this->meta['description'] = '';

        $this->data['title'] = '';
        $this->data['content'] = '';
    }

    function __show_page()
    {
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');
        if (!$view) {
            $view=APPPATH."/views/default";
        }
        $this->meta['theme'] = $theme;
        $this->data['theme'] = $theme;
        $this->load->view("$view/../cabinet_billing/detstat", $this->data);
    }

    function index($user_id, $session_id, $get_params)
    {
        date_default_timezone_set('UTC');
        if(!$view){
            $view=APPPATH."/views/default";
        }

        session_start();
        $_GET=json_decode(urldecode($get_params), true);
        $this->data['title'] = '';
        $this->data['content'] = '';
        $_SESSION['session_id'] = $session_id;
        $_SESSION['view_id']=$user_id;
        include_once('/usr/local/lib/billing_api_tools/web.php');
        $api = new WebCabinetApi($session_id);
        $_SESSION['cab']['vpn_const']=$api->get_vpn_const();
        $fp_lock = fopen("/tmp/stat.lock", "w+");
        $timeout = 0;
        while (!flock($fp_lock, LOCK_EX | LOCK_NB)) {
            sleep(1);
            $timeout++;
            if ($timeout >= 20) {
                fclose($fp_lock);
                die('<pre>Сервер занят. Повторите запрос позже.</pre>');
            }
        }

        Error_Reporting(E_ALL & ~E_NOTICE & ~E_WARNING);





//оставим старую проверку
        if (!$_SESSION['cab']['session_id']) {

            if (isset($_SESSION['session_id']) && isset($_SESSION['view_id'])) {

                $_SESSION['cab']['session_id'] = $_SESSION['session_id'];
                $_SESSION['cab']['view_id'] = $_SESSION['view_id'];
                $_SESSION['cab']['is_temp'] = 1;
            } else {
                die('authorization required');
            }
        }

        define('DEBUG', false);

        require(APPPATH."libraries/detstat_core.php");
        require(APPPATH. "/libraries/detstat_db.php");

        //Режим (top | days | detail)
        $mode = isset($_GET['mode']) ? $_GET['mode'] : 'top';

        $_SESSION['stat_view_mode'] = $mode;

        //забираем параметры подключения к бд из ics.conf
        $filedata = file_get_contents('/cfg/config.json');
        $ini_file = json_decode($filedata, true);

        $ip = $ini_file["app"]["NET_IF1_IP"];
        $ip = @strstr($ip, 0, strpos($ip, "/"));
        echo($ip);
        define('IBASE_SERV', $ini_file["app"]["DB_SRV"][0]);
        define('IBASE_HOST', $ini_file["app"]["DB_NAME"][0]);
        define('IBASE_USER', $ini_file["app"]["WEB_STATDB_USER"][0]);
        define('IBASE_PASS', $ini_file["app"]["WEB_STATDB_PASS"][0]);
        define('IBASE_CHARSET', $ini_file["app"]["WEB_DB_CHARSET"][0]);
        //Параметры фильтра
        //- дата
        $filter['month'] = isset($_GET['month']) ? (int)$_GET['month'] : date('m');
        $filter['yyear'] = isset($_GET['yyear']) ? (int)$_GET['yyear'] : date('Y');

        $first_day = isset($_GET['detail_day']) ? date('d', $_GET['detail_day']) : '01';
        $last_day = isset($_GET['detail_day']) ? date('d', $_GET['detail_day']) : date('t', $filter['time_from']);

        $filter['time_from'] = mktime(0, 0, 0, $filter['month'], $first_day, $filter['yyear']);
        $filter['time_to'] = mktime(23, 59, 59, $filter['month'], $last_day - 1, $filter['yyear']);

        $filter['fdate1'] = date('d.m.Y', $filter['time_from']);
        $filter['fdate2'] = date('d.m.Y', $filter['time_to']);
        $filter['ftime1'] = date('H:i', $filter['time_from']);
        $filter['ftime2'] = date('H:i', $filter['time_to']);

        if ($mode == 'detail') {
            if (isset($_GET['fdate1'])) {
                $filter['fdate1'] = $_GET['fdate1'];
                $filter['ftime1'] = $_GET['ftime1'];
                $filter['time_from'] = date2stamp($filter['fdate1'], $filter['ftime1']);
                $filter['month'] = date('m', $filter['time_from']);
                $filter['yyear'] = date('Y', $filter['time_from']);
                if (isset($_GET['fdate2'])) {
                    $filter['fdate2'] = $_GET['fdate2'];
                    $filter['ftime2'] = $_GET['ftime2'];
                    $filter['time_to'] = date2stamp($filter['fdate2'], $filter['ftime2']);
                }
            }
        }

        //- IP адреса
        $filter['ip1'] = isset($_GET['ip1']) ? $_GET['ip1'] : '';
        $filter['ip2'] = isset($_GET['ip2']) ? $_GET['ip2'] : '';

        //- S-порт
        $filter['sport1'] = isset($_GET['sport1']) ? $_GET['sport1'] : '';
        $filter['sport2'] = isset($_GET['sport2']) ? $_GET['sport2'] : '';

        //- D-порт
        $filter['dport1'] = isset($_GET['dport1']) ? $_GET['dport1'] : '';
        $filter['dport2'] = isset($_GET['dport2']) ? $_GET['dport2'] : '';

        //- протокол
        $filter['proto'] = isset($_GET['proto']) ? (int)$_GET['proto'] : '';

        //- направление
        $filter['direction'] = isset($_GET['direction']) ? $_GET['direction'] : 'any';

        //- подсеть
        $filter['ruleset'] = isset($_GET['ruleset']) ? (int)$_GET['ruleset'] : 0;

        //- по всем пользователям
        $filter['all_users'] = isset($_GET['all_users']) ? $_GET['all_users'] : 0;

        //- сортировать по объему
        $filter['trafsort'] = isset($_GET['trafsort']) ? $_GET['all_users'] : 0;

        //- режим
        $filter['mode'] = $mode;
        if ($mode == 'top') {
            $filter['mode'] = 'topmonth';
        }
        if ($mode == 'days') {
            $filter['mode'] = 'days';
        }
        if ($mode == 'detail') {
            $filter['mode'] = 'main';
        }
        if ($mode == 'detail' && isset($_GET['download']) && (int)$_GET['download'] == 1) {
            $filter['filemode'] = 1;
        }

        //- страницы
        $page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
        $perpage = 100;

        $_SESSION['filter'] = $filter;

        $request = getCommandLine($user_id, $filter);

        if (!$filter['filemode']) {

            //вывод статистику на странице браузера
            $records = getRecordsCount($request, $user_id);
            $xml = getStatXML($request, $user_id, $page, $perpage);
        } else {

            //отправка пользователю текстового файла со статистикой
            $filename = getStatFilePath($request, $user_id);
            sendFileToUser('stat_' . $filter['fdate1'] . '_' . $filter['fdate2'] . '.txt', $filename);
            die();
        }

        flock($fp_lock, LOCK_UN);
        fclose($fp_lock);

        $data['stat_table'] = xml2html($xml, $view.'/../cabinet_billing/detstat.xml');
        $data['user_id'] = $user_id;
//        $data['user'] = getUserName($user_id);
        $data['filter'] = $filter;
        $filter['mode'] = $mode;
        $data['filter_query'] = urldecode(http_build_query($filter));
        $data['mode'] = $mode;
        $data['pages'] = ceil($records / $perpage);
        $data['page'] = $page;
        $data['perpage'] = $perpage;
        $data['records'] = $records;
        $data['show_from'] = (($page - 1) * $perpage) + 1;
        $data['show_to'] = ($data['show_from'] + $perpage < $records) ? $data['show_from'] + $perpage - 1 : $records;
        $this->data['data'] = $data;
        $this->__show_page();
        if ($_SESSION['cab']['is_temp']) {
            unset($_SESSION['cab']['session_id']);
        }
    }

    function ajax_resolve($a, $b, $c)
    {
        include_once $_SERVER["DOCUMENT_ROOT"] . '/application/libraries/DNS2.php';
        global $page;

        Error_Reporting(E_ALL & ~E_NOTICE & ~E_WARNING);
        if (!class_exists('Net_DNS2_Resolver')) {
            die('');
        }
        $DNS_Resolver = new Net_DNS2_Resolver();
        $ip = $_REQUEST['ip'];
        $ip = trim($ip);
        $ans = '';
        try {
            $result = $DNS_Resolver->query($ip, 'PTR');
        } catch (Net_DNS2_Exception $e) {
            echo "--";
        }
        if ($result == 0) return;
        foreach ($result->answer as $value) $ans = "$ans $value->ptrdname";
        echo trim($ans);
    }

}

?>
