<?php

class Plans extends CI_Controller {

    var $meta = array();
    var $data = array();

    public function __construct() {
        parent::__construct();

        $this->meta['title'] = '';
        $this->meta['keywords'] = '';
        $this->meta['description'] = '';

        $this->data['title'] = '';
        $this->data['content'] = '';

        $this->data['breadcrumbs'] = array("Главная" => "/", "Тарифы" => "/plans/");
    }

    function __show_page() {
        $theme = $this->config->item('theme');
        $view = $this->config->item('view');

        $this->meta['theme'] = $theme;
        $this->data['theme'] = $theme;

        $this->load->view("$view/html_start", $this->meta);
        $this->load->view("$view/header");
        $this->load->view("$view/data", $this->data);
        $this->load->view("$view/footer");
        $this->load->view("$view/html_end");
    }

    function __parse_tarifs($xml_plansets) {
        $plansets = array();
        $tarifs = array();

        foreach ($xml_plansets as $xml_planset) {

            $xml_planset = $xml_planset['TEXT'];

            if (strstr($xml_planset, '</tariff>')) {
                $tarifs[] = $plansets;
                $plansets = array();
                continue;
            }

            if (strstr($xml_planset, '<tariff')) {
                preg_match('/id="([^"]*)"/i', $xml_planset, $matches);
                $planset['id'] = $matches[1];

                preg_match('/name="([^"]*)"/i', $xml_planset, $matches);
                $planset['name'] = $matches[1];

                preg_match('/abonpay="([^"]*)"/i', $xml_planset, $matches);
                $planset['abonpay'] = $matches[1];

                $planset['tarif'] = 1;

                $plansets[] = $planset;
                continue;
            }

            if (strstr($xml_planset, '<planset name')) {

                $planset['tarif'] = 0;

                preg_match('/name="([^"]*)"/i', $xml_planset, $matches);
                $planset['name'] = $matches[1];

                preg_match('/in_price="([^"]*)"/i', $xml_planset, $matches);
                $planset['in_price'] = $matches[1];

                preg_match('/out_price="([^"]*)"/i', $xml_planset, $matches);
                $planset['out_price'] = $matches[1];

                $plansets[] = $planset;
                continue;
            }
        }
        return $tarifs;
    }

    function __parse_rules($xml_rules) {
        $rules = array();

        foreach ($xml_rules as $xml_rule) {

            $xml_rule = $xml_rule['TEXT'];

            if (strstr($xml_rule, '</ruleset>')) {
                continue;
            }

            if (strstr($xml_rule, '<ruleset')) {
                preg_match('/name="([^"]*)"/i', $xml_rule, $matches);
                $rules[] = array('name' => $matches[1], 'ruleset' => 1);
                continue;
            }

            if (strstr($xml_rule, '<rule net')) {
                $rule['ruleset'] = 0;

                preg_match('/net="([^"]*)"/i', $xml_rule, $matches);
                $rule['net'] = $matches[1];

                preg_match('/mask="([^"]*)"/i', $xml_rule, $matches);
                $rule['mask'] = $matches[1];

                preg_match('/policy="([^"]*)"/i', $xml_rule, $matches);
                $rule['policy'] = $matches[1];

                $rules[] = $rule;
                continue;
            }
        }
        return $rules;
    }

    function __get_html_tarifs($tarifs) {
        $html = "";
        foreach ($tarifs as $plansets) {

            $html.="<h3>Тариф: " . $plansets[0]['name'] . '<span style="font-size:15px;color:#666">';
            if ($plansets[0]['abonpay']) {
                $html.="(Абонентская плата: " . $plansets[0]['abonpay'] . ")";
            }
            $html.="</span></h3>";

            if (sizeof($plansets) > 1) {
                $html.='<div id="stat_table_wrap"><table width="100%" id="stat_table" cellspacing="0"><tbody>';
                foreach ($plansets as $num => $planset) {
                    $cl = "";
                    if ($num % 2) {
                        $cl = 'class="odd"';
                    }
                    $html.="<tr $cl>";
                    if ($planset['tarif']) {
                        $html.='<td class="head">Подсеть</td>
                            <td class="head" width="100">Цена Вх.</td>
                            <td class="head" width="100">Цена Исх.</td>';
                    } else {
                        $html.="<td>${planset['name']}</td>
                            <td>${planset['in_price']}</td>
                            <td>${planset['out_price']}</td>";
                    }
                    $html.="</tr>";
                }
                $html.='</tbody></table></div>';
            }
        }
        return $html;
    }

    function __get_html_tarifs_order($tarifs) {
        $html = '<form action="" method="post"> <input type="hidden" name="user_id" value="' . $this->ideco_cab->cabRequest('id', 'str', '') . '" id="connect_id" />';
        foreach ($tarifs as $plansets) {

            $html.='<input type="radio" name="tarif_id" value="' . $plansets[0]['id'] . '" id="tarif' . $plansets[0]['id'] . '" style="position:relative;top:18px;float:left;font-size:20px; width:20px; height:20px "><label for="tarif' . $plansets[0]['id'] . '"><h3>Тариф: ' . $plansets[0]['name'] . '<span style="font-size:15px;color:#666">';
            if ($plansets[0]['abonpay']) {
                $html.="(Абонентская плата: " . $plansets[0]['abonpay'] . ")";
            }
            $html.="</input></span></h3></label>";

            if (sizeof($plansets) > 1) {
                $html.='<div id="stat_table_wrap"><table width="100%" id="stat_table" cellspacing="0"><tbody>';
                foreach ($plansets as $num => $planset) {
                    $cl = "";
                    if ($num % 2) {
                        $cl = 'class="odd"';
                    }
                    $html.="<tr $cl>";
                    if ($planset['tarif']) {
                        $html.='<td class="head">Подсеть</td>
                            <td class="head" width="100">Цена Вх.</td>
                            <td class="head" width="100">Цена Исх.</td>';
                    } else {
                        $html.="<td>${planset['name']}</td>
                            <td>${planset['in_price']}</td>
                            <td>${planset['out_price']}</td>";
                    }
                    $html.="</tr>";
                }
                $html.='</tbody></table></div>';
            }
        }
        return $html . ' <input class="reg_b" type="submit" name="set_tarif" value="Указать тариф"/></form>';
    }

    function __get_html_rules($rules) {
        $html = '<h3>Подсети тарифного плана</h3>
            <div id="stat_table_wrap">
            <table width="100%" id="stat_table" cellspacing="0">        
            <tbody>';
        foreach ($rules as $num => $rule) {
            $cl = "";
            if ($num % 2) {
                $cl = 'class="odd"';
            }
            $html.="<tr $cl>";
            if ($rule['ruleset']) {
                $html.='<td colspan="3" class="head">' . $rule['name'] . "</td>";
            } else {
                $html.="<td>" . $rule['net'] . "</td>";
                $html.="<td>" . $rule['mask'] . "</td>";
                $html.="<td>" . $rule['policy'] . "</td>";
            }
            $html.="</tr>";
        }
        $html.='</tbody></table></div>';
        return $html;
    }

    function index() {
        $this->data['title'] = 'Тарифы';

        $xml_plansets = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_TARIFF_GET2(null, null)');
        $tarifs = $this->__parse_tarifs($xml_plansets);
        $this->data['content'] = $this->__get_html_tarifs($tarifs);

        $xml_rules = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_TARIFF_RULES(null, null)');
        $rules = $this->__parse_rules($xml_rules);
        $this->data['content'].=$this->__get_html_rules($rules);

        $this->__show_page();
    }

    function additional() {
        $this->meta['title'] = 'Дополнительные услуги';

        $this->data['title'] = $this->meta['title'];
        $this->data['content'] = $this->Static_html->get('plans_additional');

        $this->__show_page();
    }

    function traffic() {
        $this->meta['title'] = '';

        $this->data['title'] = $this->meta['title'];
        $this->data['content'] = '';

        $this->__show_page();
    }

    function unlimited() {
        $this->meta['title'] = '';

        $this->data['title'] = $this->meta['title'];
        $this->data['content'] = '';

        $this->__show_page();
    }

    function order() {
        $this->data['title'] = 'Выберете пожалуйста тариф';
        $user_id = $this->ideco_cab->cabRequest('user_id');
        $tarif_id = intval($this->ideco_cab->cabRequest('tarif_id'));
        if ($this->ideco_cab->cabRequest('set_tarif') && $tarif_id > 0) {
            $sql = "select * from web_user_tarif_edit('" . $user_id . "','" . $tarif_id . "')";
            /*print_r($sql);
            exit();*/
            $result = $this->ideco_db->cabQuerySingle($sql);
            $this->data['content'] = "Спасибо что нас выбрали! Наши менеджеры скоро свяжутся с вами.";
            $this->__show_page();
        }
	else
	{
    	    $xml_plansets = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_TARIFF_GET2(null, null)');
    	    $tarifs = $this->__parse_tarifs($xml_plansets);
    	    $this->data['content'] = $this->__get_html_tarifs_order($tarifs);

    	    $xml_rules = $this->ideco_db->cabQueryMulti('SELECT * FROM WEB_TARIFF_RULES(null, null)');
    	    $rules = $this->__parse_rules($xml_rules);
    	    $this->data['content'].=$this->__get_html_rules($rules);

    	    $this->__show_page();
	}
    }

}

?>
