<?php

//============================================================================//
//============================================================================//

    if ($mode == 'sysstate'){

        preg_match('/cpuusage="([^"]*)"/i', $xml_file, $matches);       $sysstate['cpuusage'] = $matches[1];

        preg_match('/loadavr1="([^"]*)"/i', $xml_file, $matches);       $sysstate['loadavr1'] = $matches[1];
        preg_match('/loadavr2="([^"]*)"/i', $xml_file, $matches);       $sysstate['loadavr2'] = $matches[1];
        preg_match('/loadavr3="([^"]*)"/i', $xml_file, $matches);       $sysstate['loadavr3'] = $matches[1];

        preg_match('/mem_total="([^"]*)"/i', $xml_file, $matches);      $sysstate['mem_total'] = $matches[1];
        preg_match('/mem_free="([^"]*)"/i', $xml_file, $matches);       $sysstate['mem_free'] = $matches[1];

        preg_match('/swap_total="([^"]*)"/i', $xml_file, $matches);     $sysstate['swap_total'] = $matches[1];
        preg_match('/swap_free="([^"]*)"/i', $xml_file, $matches);      $sysstate['swap_free'] = $matches[1];

        preg_match('/vpn_act="([^"]*)"/i', $xml_file, $matches);        $sysstate['vpn_act'] = $matches[1];
        preg_match('/vnp_auth="([^"]*)"/i', $xml_file, $matches);       $sysstate['vnp_auth'] = $matches[1];

        preg_match('/backup_size="([^"]*)"/i', $xml_file, $matches);    $sysstate['backup_size'] = $matches[1];
        preg_match('/bd_size="([^"]*)"/i', $xml_file, $matches);        $sysstate['bd_size'] = $matches[1];

    }

//============================================================================//
//============================================================================//

    if ($mode == 'top'){

        $top        = array();
        $top_rows   = explode("\n", $xml_file);

        foreach ($top_rows as $row){

            if (!strstr($row, '<top_item')) { continue; }

            $top_item = array();

            preg_match('/pid="([^"]*)"/i', $row, $matches);        $top_item['pid'] = $matches[1];
            preg_match('/user="([^"]*)"/i', $row, $matches);       $top_item['user'] = $matches[1];
            preg_match('/pri="([^"]*)"/i', $row, $matches);        $top_item['pri'] = $matches[1];
            preg_match('/ni="([^"]*)"/i', $row, $matches);         $top_item['ni'] = $matches[1];
            preg_match('/size="([^"]*)"/i', $row, $matches);       $top_item['size'] = $matches[1];
            preg_match('/rss="([^"]*)"/i', $row, $matches);        $top_item['rss'] = $matches[1];
            preg_match('/share="([^"]*)"/i', $row, $matches);      $top_item['share'] = $matches[1];
            preg_match('/stat="([^"]*)"/i', $row, $matches);       $top_item['stat'] = $matches[1];
            preg_match('/cpu="([^"]*)"/i', $row, $matches);        $top_item['cpu'] = $matches[1];
            preg_match('/mem="([^"]*)"/i', $row, $matches);        $top_item['mem'] = $matches[1];
            preg_match('/time="([^"]*)"/i', $row, $matches);       $top_item['time'] = $matches[1];
            preg_match('/cpunum="([^"]*)"/i', $row, $matches);     $top_item['cpunum'] = $matches[1];
            preg_match('/command="([^"]*)"/i', $row, $matches);    $top_item['command'] = $matches[1];

            $top[] = $top_item;

        }

    }

//============================================================================//
//============================================================================//

    if ($mode == 'iptraf'){

        $traf        = array();
        $traf_stat   = array();
        $traf_rows   = explode("\n", $xml_file);

        foreach ($traf_rows as $row){

            if (!strstr($row, '<iptraf_item') && !strstr($row, '<iptraf_stat')) { continue; }

            if (strstr($row, '<iptraf_item')){
                $traf_item = array();
                preg_match('/size="([^"]*)"/i', $row, $matches);    $traf_item['size'] = $matches[1];
                preg_match('/ip1="([^"]*)"/i', $row, $matches);     $traf_item['ip1']  = $matches[1];
                preg_match('/ip2="([^"]*)"/i', $row, $matches);     $traf_item['ip2']  = $matches[1];
                $traf[] = $traf_item;            
            }

            if (strstr($row, '<iptraf_stat')){
                preg_match('/time_delta="([^"]*)"/i', $row, $matches);       $traf_stat['time_delta'] = $matches[1];
                preg_match('/connection_count="([^"]*)"/i', $row, $matches); $traf_stat['connection_count'] = $matches[1];
                preg_match('/str_count="([^"]*)"/i', $row, $matches);        $traf_stat['str_count'] = $matches[1];
                preg_match('/pckg_avrg_size="([^"]*)"/i', $row, $matches);   $traf_stat['pckg_avrg_size'] = $matches[1];
                preg_match('/conn_avrg_size="([^"]*)"/i', $row, $matches);   $traf_stat['conn_avrg_size'] = $matches[1];
            }

        }

    }

//============================================================================//
//============================================================================//

?>

<h3>Системный монитор</h3>

<ul id="cab_tabs" class="ui-tabs-nav" style="margin-bottom:15px;margin-top:15px;">
    <li class="<?php if($mode=='sysstate'){ ?>ui-tabs-selected<?php } ?>"><a href="<?php echo '/cabinet/sysmon/';?>sysstate"><span>Системные ресурсы</span></a></li>
    <li class="<?php if($mode=='top'){ ?>ui-tabs-selected<?php } ?>"><a href="<?php echo '/cabinet/sysmon/';?>top"><span>Процессы</span></a></li>
    <li class="<?php if($mode=='iptraf'){ ?>ui-tabs-selected<?php } ?>"><a href="<?php echo '/cabinet/sysmon/';?>iptraf"><span>Последние соединения</span></a></li>
    <li class="<?php if($mode=='squid'){ ?>ui-tabs-selected<?php } ?>"><a href="<?php echo '/cabinet/sysmon/';?>squid"><span>Запросы прокси-серверу</span></a></li>
    <li class="<?php if($mode=='mrtg'){ ?>ui-tabs-selected<?php } ?>"><a href="<?php echo '/cabinet/sysmon/';?>mrtg"><span>Графики загруженности</span></a></li>
</ul>

<?php if ($mode == 'sysstate') { ?>

    <div id="stat_table_wrap">
        <table id="stat_table" cellpadding="0" cellspacing="0" border="0" width="100%">
            <thead>
                <tr>
                    <th width="">Характеристика</th>
                    <th width="">Значение</th>
                </tr>
            </thead>
            <tbody>
                <tr class="odd">
                    <td width="200"><strong>Загрузка процессора:</strong></td>
                    <td><?php echo $sysstate['cpuusage']; ?>%</td>
                </tr>
                <tr>
                    <td><strong>Загрузка системы:</strong></td>
                    <td><?php echo $sysstate['loadavr1']; ?>, <?php echo $sysstate['loadavr2']; ?>, <?php echo $sysstate['loadavr3']; ?></td>
                </tr>
                <tr class="odd">
                    <td><strong>Память (всего, свободно):</strong></td>
                    <td><?php echo $sysstate['mem_total']; ?>, <?php echo $sysstate['mem_free']; ?></td>
                </tr>
                <tr>
                    <td><strong>Подкачка (всего, свободно):</strong></td>
                    <td><?php echo $sysstate['swap_total']; ?>, <?php echo $sysstate['swap_free']; ?></td>
                </tr>
                <tr class="odd">
                    <td><strong>Активные сессии VPN:</strong></td>
                    <td><?php echo $sysstate['vpn_act']; ?></td>
                </tr>
                <tr>
                    <td><strong>Авторизованные сессии VPN:</strong></td>
                    <td><?php echo $sysstate['vnp_auth']; ?></td>
                </tr>
                <tr class="odd">
                    <td><strong>Занято резервными копиями:</strong></td>
                    <td><?php echo $sysstate['backup_size']; ?></td>
                </tr>
                <tr>
                    <td><strong>Занято базами данных:</strong></td>
                    <td><?php echo $sysstate['bd_size']; ?></td>
                </tr>
            </tbody>
        </table>
    </div>
    
<?php } ?>

<?php if ($mode == 'top') { ?>

    <div style="color:gray;margin-bottom:10px;">
        Наведите курсор на заголовок столбца, чтобы увидеть подсказку.
    </div>

    <div id="stat_table_wrap">
        <table id="stat_table" cellpadding="0" cellspacing="0" border="0" width="100%">
            <thead>
                <tr>
                    <th width=""><a title="Идентификатор процесса">PID</a></th>
                    <th width=""><a title="Пользователь, с правами которого выполняется процесс">User</a></th>
                    <th width=""><a title="Приоритет процесса">PRI</a></th>
                    <th width=""><a title="Изменение приоритета процесса (nice)">NI</a></th>
                    <th width=""><a title="Размер образа, Кб">Size</a></th>
                    <th width=""><a title="Общий объем физической памяти, используемой процессом">RSS</a></th>
                    <th width=""><a title="Объем разделяемой памяти, используемой процессом">Share</a></th>
                    <th width=""><a title="Состояние процесса">Stat</a></th>
                    <th width=""><a title="Процент использования процессорного времени">%CPU</a></th>
                    <th width=""><a title="Процент использования памяти">%Mem</a></th>
                    <th width=""><a title="Процессорное время">Time</a></th>
                    <th width=""><a title="Номер процессора">CPU</a></th>
                    <th width=""><a title="Выполняемая команда">Command</a></th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($top as $num=>$item) { ?>
                    <tr <?php if ($num%2){ ?>class="odd"<?php } ?>>
                        <td><?php echo $item['pid']; ?></td>
                        <td><?php echo $item['user']; ?></td>
                        <td><?php echo $item['pri']; ?></td>
                        <td><?php echo $item['ni']; ?></td>
                        <td><?php echo $item['size']; ?></td>
                        <td><?php echo $item['rss']; ?></td>
                        <td><?php echo $item['share']; ?></td>
                        <td><?php echo $item['stat']; ?></td>
                        <td><?php echo $item['cpu']; ?></td>
                        <td><?php echo $item['mem']; ?></td>
                        <td><?php echo $item['time']; ?></td>
                        <td><?php echo $item['cpunum']; ?></td>
                        <td><?php echo $item['command']; ?></td>
                    </tr>
                <?php } ?>
            </tbody>
        </table>
    </div>

<?php } ?>

<?php if ($mode == 'iptraf') { ?>

    <div style="margin-bottom:10px">
        <strong>Последние соединения за <?php echo $traf_stat['time_delta']; ?> сек.</strong>
    </div>

    <div id="stat_table_wrap">
        <table id="stat_table" cellpadding="0" cellspacing="0" border="0" width="100%">
            <thead>
                <tr>
                    <th width="">IP-адрес источника</th>
                    <th width="">IP-адрес отправителя</th>
                    <th width="">Размер</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($traf as $num=>$item) { ?>
                    <tr <?php if ($num%2){ ?>class="odd"<?php } ?>>
                        <td><?php echo $item['ip1']; ?></td>
                        <td><?php echo $item['ip2']; ?></td>
                        <td><?php echo $item['size']; ?></td>
                    </tr>
                <?php } ?>
            </tbody>
        </table>
    </div>

    <div id="stat_table_wrap" style="margin-top:4px">
        <table id="stat_table" cellpadding="0" cellspacing="0" border="0" width="100%">
            <tbody>
                <tr class="odd">
                    <td width="250"><strong>Количество соединений за <?php echo $traf_stat['time_delta']; ?> сек.:</strong></td>
                    <td><?php echo $traf_stat['connection_count']; ?></td>
                </tr>
                <tr>
                    <td><strong>Количество пакетов за <?php echo $traf_stat['time_delta']; ?> сек.:</strong></td>
                    <td><?php echo $traf_stat['str_count']; ?></td>
                </tr>
                <tr class="odd">
                    <td><strong>Средний размер пакета:</strong></td>
                    <td><?php echo $traf_stat['pckg_avrg_size']; ?></td>
                </tr>
                <tr>
                    <td><strong>Средний трафик за соединение:</strong></td>
                    <td><?php echo $traf_stat['conn_avrg_size']; ?></td>
                </tr>
            </tbody>
        </table>
    </div>

<?php } ?>

<?php if ($mode == 'mrtg') { ?>

    <iframe frameborder="0px" src="/mrtg/session_<?php echo $_SESSION['cab']['session_id']; ?>/index.html" style="border:0px; width:100%; height: 600px; margin-top:25px;">
    </iframe>

<?php } ?>



