<?php 

    // Поскольку процедуры WEB_TARIFF_GET и WEB_TARIFF_RULES возвращают
    // данные в виде XML, ниже распарсим их вывод в массивы

    // парсим название и состав тарифа
    $plansets = array();
    foreach($xml_plansets as $xml_planset){

        $xml_planset = $xml_planset['TEXT'];

        if (strstr($xml_planset, '</tarif>')){ continue; }

        if (strstr($xml_planset, '<tariff')){
            preg_match('/name="([^"]*)"/i', $xml_planset, $matches);
            $plansets[] = array('name'=>$matches[1], 'tarif'=>1);
            continue;
        }

        if (strstr($xml_planset, '<planset name')){

            $planset['tarif']    = 0;

            preg_match('/name="([^"]*)"/i', $xml_planset, $matches);
            $planset['name']        = $matches[1];

            preg_match('/in_price="([^"]*)"/i', $xml_planset, $matches);
            $planset['in_price']       = $matches[1];

            preg_match('/out_price="([^"]*)"/i', $xml_planset, $matches);
            $planset['out_price']     = $matches[1];

            $plansets[] = $planset;
            continue;

        }

    }

    // парсим состав тарифных правил
    $rules = array();

    foreach($xml_rules as $xml_rule){

        $xml_rule = $xml_rule['TEXT'];

        if (strstr($xml_rule, '</ruleset>')){ continue; }

        if (strstr($xml_rule, '<ruleset')){
            preg_match('/name="([^"]*)"/i', $xml_rule, $matches);
            $rules[] = array('name'=>$matches[1], 'ruleset'=>1);
            continue;
        }

        if (strstr($xml_rule, '<rule net')){
            $rule['ruleset']    = 0;

            preg_match('/net="([^"]*)"/i', $xml_rule, $matches);
            $rule['net']        = $matches[1];

            preg_match('/mask="([^"]*)"/i', $xml_rule, $matches);
            $rule['mask']       = $matches[1];

            preg_match('/policy="([^"]*)"/i', $xml_rule, $matches);
            $rule['policy']     = $matches[1];

            $rules[] = $rule;
            continue;
        }

    }

    //парсим список тарифов для перехода
    $tarlist = array();
    //var_dump($xml_tar);
    foreach($xml_tarlist as $xml_tar){
        preg_match('/id="([^"]*)"/i', $xml_tar['TEXT'], $matches);
        $plan_id = @$matches[1];

        preg_match('/name="([^"]*)"/i', $xml_tar['TEXT'], $matches);
        $plan_name = @$matches[1];

        if ($plan_id && $plan_name){
            $tarlist[] = array('id'=>$plan_id, 'name'=>$plan_name);
        }
    }

?>

<?php if ($result){ ?>
<div style="color:green;margin-top:10px;font-weight:bold;font-size:16px;">
    <?php
    echo $result;
    ?>
</div>
<?php } ?>
<br />
Текущий тариф: <?php echo $user['TARIF_NAME']; ?>
<br />

<?php if (count($tarif_uslugi) > 0): // на тарифе есть услуги
?>
<h3><?php echo $user['TARIF_NAME']; ?></h3>
Услуги в тарифе:<br />
<div id="stat_table_wrap">
    <table width="100%" id="stat_table" cellspacing="0"  class="odd_even">
        <thead>
        <tr>
            <th>Услуга</th>
            <th>Цена</th>
            <th>Оплата</th>
        </tr>
        </thead>
        <tbody>
           <?php $itogo=0; foreach($tarif_uslugi as $num=>$usl){
               if (intval($usl['IN_TARIF']) == 0) continue;

               $itogo= $itogo + $usl['SUMMA'];
               $itogo_arr[$usl['PERIOD']] = $itogo_arr[$usl['PERIOD']] + $usl['ABONENT_PAY'];
               ?>
                <tr>
                        <td><?php echo $usl['NAME']; ?></td>
                        <td><?php echo $usl['ABONENT_PAY']; ?></td>
                        <td><?php echo $usl['PERIOD']; ?></td>
                </tr>
           <?php } ?>
           <!--
           <tr>
           <td>Итого:</td>
           <td></td>
           <td><?php echo $itogo;?></td>
           </tr>
           -->
           <tr>
               <td>Итого Ежемесячно:</td>
               <td></td>
               <td><?php echo $itogo_arr['Ежемесячно'];?></td>
           </tr>
        </tbody>
    </table>
</div>
<?php
endif; //$tarif_uslugi
?>
<?php if ($tarlist) { ?>
<br />
        <div class="frame">
            <h3>Смена тарифа</h3>
            <form action="" method="post">
                <table cellpadding="3" cellspacing="0" border="0" width="100%" style="margin-top:15px">
                    <tr>
                        <td width="120">Перейти на тариф: </td>
                        <td>
                            <select name="new_plan_id" style="width:99%">
                                <?php foreach($tarlist as $tarif) { ?>
                                    <option value="<?php echo $tarif['id']; ?>"><?php echo $tarif['name']; ?></option>
                                <?php } ?>
                            </select>
                        </td>
                        <td width="120">
                            <input type="submit" id="change_tarif" name="change_tarif" value="Сменить тариф" />
                        </td>
                    </tr>
                </table>
            </form>
        </div>

<?php } //tarlist
?>