from cms.include import *
# тут код, который ищет все модельки, собирает их целиком и регистрирует из в sqlalchemy

print('import models')


# TODO: check все классы в наследовании имеют одно и то же имя
# hierarchy = ['cms', 'common', 'modules', 'plugins', 'custom']
# TODO: зарефачить
# TODO: !!! Сохранять инфомодель в текстовый файл:
#  class User
#      class CmsModel cms/models/base_model.py
#          field id = IntegerField(primary_key=True)
#          field name = String256Field(index=True)
#      class fields.User modules/users/fields/user.py
#      class modules.User modules/users/fields/user.py
#
def make_models():
    def add_to_models_list(models_list, path, name, obj):
        if name not in models_list:
            models_list[name] = {
                # Иерархия наследования
                'cms': [],
                'common': [],
                'modules': [],
                'plugins': [],
                'custom': [],
            }

        if path.startswith('cms.contrib'):
            return

        if path.startswith('cms'):
            models_list[name]['cms'].append(obj)
        elif path.startswith('common'):
            models_list[name]['common'].append(obj)
        elif path.startswith('modules'):
            models_list[name]['modules'].append(obj)
        elif path.startswith('plugins'):
            models_list[name]['plugins'].append(obj)
        elif path.startswith('custom'):
            models_list[name]['custom'].append(obj)
        else:
            raise Exception('Неизвестный источник для импорта полей для моделей: {}'.format(path))

    models_list = {}
    for dirname, dirnames, filenames in os.walk(PROJECT_DIR):
        dirname = dirname.replace(PROJECT_DIR, '')
        # FIXME: ./venv/ - вроде как лишнее
        skip_dir = False
        for ignoire_prefix in ('./venv/', '/venv/'):
            
            if dirname.startswith(ignoire_prefix):
                skip_dir = True
            # else:
            #    print('Not match', dirname, ignoire_prefix)
        if skip_dir:
             continue
        for filename in filenames:
            if dirname.endswith('fields') or dirname.endswith('models'):
                print(dirname,filename)
                module_path = '.'.join(v for v in dirname.split('/') if v)
                print(module_path+'.'+filename.split('.')[0])
                model_module = importlib.import_module(module_path+'.'+filename.split('.')[0], package=None)

                for obj_name, obj in model_module.__dict__.items():
                    if inspect.isclass(obj) and issubclass(obj, cms.models.BaseModel):
                        add_to_models_list(models_list, module_path, obj_name, obj)

    with open(os.path.join(PROJECT_DIR, '__autogen_models.py'), 'w+') as model_file:
        model_file.write("# Autogenerated by manage.py make_models. \n")
        model_file.write("from cms.include import *\n\n")

        for name, model_obj_list in models_list.items():
            hierarchy = []
            for model_type in ['cms', 'common', 'modules', 'plugins', 'custom']:
                for model in model_obj_list[model_type]:
                    # Очищаем очередь от классов, уже имеющихся в иерархии наследования
                    hierarchy = [m for m in hierarchy if not issubclass(model, m)]
                    hierarchy.append(model)

            for imp_model in hierarchy:
                model_file.write('import {}\n'.format(imp_model.__module__))

            model_file.write('class {}({}): pass\n\n'.format(name, ','.join(['{}.{}'.format(m.__module__, m.__name__) for m in hierarchy])))
            # model_file.write('class {}({},APP.declarative_base): pass\n\n'.format(name, ','.join(['{}.{}'.format(m.__module__, m.__name__) for m in hierarchy])))

            # globals()[name] = type(name, tuple(hierarchy), {})
        model_file.flush()
        # Перезагружаем модуль с моделями
        model_file.flush()
        importlib.reload(models)

        # Сохранил вариант с подгрузкой из файла,
        #   но SA модели, лучше будет генерить DataProvider динамически
        # sqlalchemy_url = getattr(config, 'SQLALCHEMY_DATABASE_URI', None)
        # if sqlalchemy_url:
        #     # Допишем модели sqlalchemy в model_file
        #     from cms.cms_modules.data_providers.sqlalchemy import SQLAlchemyDataDriver
        #     sa_models_py = SQLAlchemyDataDriver.make_models(models)
        #     model_file.write(sa_models_py)
        #     model_file.flush()
        #     importlib.reload(models)
