# Magage.py занимается построением аппликейшена и не переопределяет функции и не создает функции в апп
import logging
import os

with open(os.path.join(os.path.dirname(os.path.realpath(__file__)), '../__autogen_models.py'), 'w') as model_file:
    model_file.write('#clean')

from cms.include import *
from cms.data_providers.base import init_ds, init_db
from cms import make_models

from pathlib import Path
import time
import subprocess
import fcntl


####
#### ВНИМАНИЕ! Изменения в файле manage.py затрутся при обновлении. Изменяйте его в каталоге ./cms/contrib/manage.py !
####

def uwsgi():
    make_models.make_models()
    install_traceback_email_notify()
    APP.config.from_pyfile('cms/config_load.py')
    start_views()
    init_ds()
    # APP.run()
    return APP


def start():
    install_traceback_email_notify()
    make_models.make_models()
    APP.config.from_pyfile('cms/config_load.py')
    start_views()
    init_ds()
    APP.run(host='0.0.0.0', port=8080)


def cms_init_db():
    make_models.make_models()
    start_views()
    init_ds()
    init_db()


def install_sentry_hook():
    if getattr(config, 'SENTRY_DSN', None):
        logging.info('Install sentry hook')
        from raven.contrib.flask import Sentry
        from raven.handlers.logging import SentryHandler
        from raven.conf import setup_logging
        sentry = Sentry(APP, dsn=config.SENTRY_DSN)
        l_handler = SentryHandler(sentry.client)
        l_handler.setLevel(logging.ERROR)
        setup_logging(l_handler)


def install_traceback_email_notify():
    cms_exception_mail = lambda x: None
    if not getattr(config, 'TRACEBACK_EMAIL_NOTIFY', None):
        return
    logging.info('Install traceback email notify')

    # ['n.krat@carbonsoft.ru', ]
    mail_to = config.TRACEBACK_EMAIL_NOTIFY
    assert isinstance(mail_to, (list, tuple)), \
        'Параметр TRACEBACK_EMAIL_NOTIFY - это список email'
    # CloudFox<noreply@cloudfox.com>
    assert getattr(config, 'TRACEBACK_EMAIL_NOTIFY_FROM', None), \
        'Укажите TRACEBACK_EMAIL_NOTIFY_FROM'
    mail_from = config.TRACEBACK_EMAIL_NOTIFY_FROM
    # Traceback monitoring-integra
    assert getattr(config, 'TRACEBACK_EMAIL_NOTIFY_SUBJECT_PREFIX', None), \
        'Укажите TRACEBACK_EMAIL_NOTIFY_SUBJECT_PREFIX'
    subject_prefix = config.TRACEBACK_EMAIL_NOTIFY_SUBJECT_PREFIX

    def traceback_exception(exception):
        import traceback
        from flask import request as __request
        from smtplib import SMTP
        from email.mime.multipart import MIMEMultipart
        from email.mime.text import MIMEText

        subject = "{} Cms traceback {} {}".format(subject_prefix, __request.method, __request.url)
        msg_contents = [
            'Проблема на веб-сервере:',
            str(exception),
            'Traceback:',
            '='*80,
            traceback.format_exc(),
        ]
        msg_contents.append('\n')
        msg_contents.append('Request Information:')
        msg_contents.append('='*80)
        environ = __request.environ
        environkeys = sorted(environ.keys())
        for key in environkeys:
            msg_contents.append('%s: %s' % (key, environ.get(key)))

        body = '\n'.join(msg_contents) + '\n'

        msg_root = MIMEMultipart('related')
        msg_root['Subject'] = subject
        msg_root['From'] = mail_from
        msg_root['To'] = ", ".join(mail_to)

        msg_alternative = MIMEMultipart('alternative')
        msg_root.attach(msg_alternative)

        plain = MIMEText(body)
        msg_alternative.attach(plain)

        try:
            smtp = SMTP('smtp.carbonsoft.ru:25251', timeout=5)
        except OSError as e:
            print(traceback.format_exc(), e)
            return

        smtp.ehlo()
        smtp.sendmail(mail_from, mail_to, msg_root.as_string())
        smtp.quit()

    APP.register_error_handler(Exception, traceback_exception)
    APP.cms_exception_mail = traceback_exception


def start_views():
    for dirname, dirnames, filenames in os.walk(PROJECT_DIR):
        dirname = dirname.replace(PROJECT_DIR, '')
        if dirname.startswith('/cms/contrib/'):
            continue
        for filename in filenames:
            if dirname.endswith('views') and filename != '__init__.py':
                module_path = '.'.join(v for v in dirname.split('/') if v)
                importlib.import_module(module_path + '.' + filename.split('.')[0], package=None)

    with APP.app_context():
        for rule in APP.url_map.iter_rules():
            print(f'Route Rule {rule.endpoint}={rule} ({rule.methods})')


def check_cms_need_update():
    logging.debug('Проверяем, нужно ли подпулить cms')
    if os.path.exists('./cms/.cms_need_update'):
        logging.info('Cms need update! Run ./manage.py cms_update')
        return

    last_check_filename = './cms/.cms_last_check_update'
    if os.path.exists(last_check_filename):
        statbuf = os.stat(last_check_filename)
        if time.time() - statbuf.st_mtime < 60 * 60:
            return

    logging.info('Проверяем, нужно ли cms обновиться')
    process = subprocess.Popen(["./cms/bin/git_check_need_pull.sh", "./cms"], stdout=subprocess.PIPE)
    output = process.communicate()[0].decode('UTF-8')
    logging.info(output.strip())
    if output.strip() == "Need to pull":
        Path('./cms/.cms_need_update').touch()
    Path(last_check_filename).touch()


def check_project_need_update_cms():
    """Не нужно сейчас.
     Считаем, что когда в проект будут копироваться сложные файлы, которые нужно обновлять - доделаем"""
    # logging.debug('Проверяем, нужно ли запускать обновление cms в проекте')
    # with open('./cms/.git/refs/heads/master', 'r') as f:
    #     cms_version = f.read().strip()
    # if not os.path.exists('./.cms_ver'):
    #     with open('./.cms_ver', 'w') as f:
    #         f.write(cms_version)
    #
    # with open('./.cms_ver', 'r') as f:
    #     project_cms_version = f.read().strip()
    #
    # if cms_version == project_cms_version:
    #     return
    #
    # logging.info('Cms обновился, требуется пересобрать проект!')
    #
    # with open('./.update_lock', 'w+') as x:
    #     try:
    #         fcntl.flock(x, fcntl.LOCK_EX | fcntl.LOCK_NB)
    #     except IOError as e:
    #         logging.info('Cms уже кто-то обновляет, подождите!')
    #         exit(0)
    #
    #     process = subprocess.Popen(["./cms/bin/update_project.sh"], stdout=subprocess.PIPE)
    #     output = process.communicate()[0].decode('UTF-8')
    #     logging.info(output.strip())
    #
    #     with open('./.cms_ver', 'w') as f:
    #         f.write(cms_version)
    #
    # os.remove('./.update_lock')
    # exit(0)


def cms_update():
    logging.info('Обновляем cms')
    process = subprocess.Popen(["./cms/bin/cms_update.sh"], stdout=subprocess.PIPE)
    output = process.communicate()[0].decode('UTF-8')
    logging.info(output)
    if os.path.exists('./.cms_need_update'):
        os.remove('./.cms_need_update')


def main():
    # TODO: запилить нормально логгирование.
    check_cms_need_update()
    install_sentry_hook()
    parser = argparse.ArgumentParser()
    parser.add_argument("command", type=str,
                        help="run command")
    args, _unknown_args = parser.parse_known_args()
    if args.command == 'uwsgi':
        return uwsgi()
    if args.command == 'start':
        start()
    elif args.command == 'cms_update':
        cms_update()
    elif args.command == 'init_db':
        cms_init_db()
    elif args.command.startswith('bin.') or args.command.startswith('sbin.'):
        importlib.import_module(args.command)
